// SerialCommTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Serial758UI.h"
#include "SerialCommTestDlg.h"
#include "UserDataDlg.h"
#include "GlobalVar.h"
#include "xrapi.h"
#include "WinIoCtl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CSerialCommTestDlg* m_pSerialCommTestDlg;

extern TESTSTRUCT m_ParTest[MAXPORTS];

/////////////////////////////////////////////////////////////////////////////
// CSerialCommTestDlg dialog


CSerialCommTestDlg::CSerialCommTestDlg(CWnd* pParent /*=NULL*/)
	: CScrollDialog(CSerialCommTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSerialCommTestDlg)
	m_ReadData1 = _T("");
	m_ReadData2 = _T("");
	m_ReadData3 = _T("");
	m_ReadData4 = _T("");
	m_ReadData5 = _T("");
	m_ReadData6 = _T("");
	m_ReadData7 = _T("");
	m_ReadData8 = _T("");
	m_WriteData1 = _T("");
	m_WriteData2 = _T("");
	m_WriteData3 = _T("");
	m_WriteData4 = _T("");
	m_WriteData5 = _T("");
	m_WriteData6 = _T("");
	m_WriteData7 = _T("");
	m_WriteData8 = _T("");
	m_CfgWriteData = _T("");
	m_CfgReadData = _T("");	
	//}}AFX_DATA_INIT
}

void CSerialCommTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CScrollDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSerialCommTestDlg)
	DDX_Control(pDX, IDC_BUTTON_INDUCEERR1, m_buttonInduceErr1);
	DDX_Control(pDX, IDC_BUTTON_INDUCEERR2, m_buttonInduceErr2);
	DDX_Control(pDX, IDC_BUTTON_INDUCEERR3, m_buttonInduceErr3);
	DDX_Control(pDX, IDC_BUTTON_INDUCEERR4, m_buttonInduceErr4);
	DDX_Control(pDX, IDC_BUTTON_INDUCEERR5, m_buttonInduceErr5);
	DDX_Control(pDX, IDC_BUTTON_INDUCEERR6, m_buttonInduceErr6);
	DDX_Control(pDX, IDC_BUTTON_INDUCEERR7, m_buttonInduceErr7);
	DDX_Control(pDX, IDC_BUTTON_INDUCEERR8, m_buttonInduceErr8);
	DDX_Control(pDX, IDC_SER8PACKETCNT, m_editPacCount8);
	DDX_Control(pDX, IDC_SER7PACKETCNT, m_editPacCount7);
	DDX_Control(pDX, IDC_SER6PACKETCNT, m_editPacCount6);
	DDX_Control(pDX, IDC_SER5PACKETCNT, m_editPacCount5);
	DDX_Control(pDX, IDC_SER4PACKETCNT, m_editPacCount4);
	DDX_Control(pDX, IDC_SER3PACKETCNT, m_editPacCount3);
	DDX_Control(pDX, IDC_SER2PACKETCNT, m_editPacCount2);
	DDX_Control(pDX, IDC_SER1PACKETCNT, m_editPacCount1);
	DDX_Control(pDX, IDC_DISPEN8, m_checkDisONOFF8);
	DDX_Control(pDX, IDC_DISPEN7, m_checkDisONOFF7);
	DDX_Control(pDX, IDC_DISPEN6, m_checkDisONOFF6);
	DDX_Control(pDX, IDC_DISPEN5, m_checkDisONOFF5);
	DDX_Control(pDX, IDC_DISPEN4, m_checkDisONOFF4);
	DDX_Control(pDX, IDC_DISPEN3, m_checkDisONOFF3);
	DDX_Control(pDX, IDC_DISPEN2, m_checkDisONOFF2);
	DDX_Control(pDX, IDC_DISPEN1, m_checkDisONOFF1);		
	DDX_Control(pDX, IDC_STOP8, m_buttonStop8);
	DDX_Control(pDX, IDC_STOP7, m_buttonStop7);
	DDX_Control(pDX, IDC_STOP6, m_buttonStop6);
	DDX_Control(pDX, IDC_STOP5, m_buttonStop5);
	DDX_Control(pDX, IDC_RUN8, m_buttonRun8);
	DDX_Control(pDX, IDC_RUN7, m_buttonRun7);
	DDX_Control(pDX, IDC_RUN6, m_buttonRun6);
	DDX_Control(pDX, IDC_RUN5, m_buttonRun5);
	DDX_Control(pDX, IDC_LOOPTEST8, m_checkLoopTest8);
	DDX_Control(pDX, IDC_LOOPTEST7, m_checkLoopTest7);
	DDX_Control(pDX, IDC_LOOPTEST5, m_checkLoopTest5);
	DDX_Control(pDX, IDC_LOOPTEST6, m_checkLoopTest6);
	DDX_Control(pDX, IDC_EBOXTX8, m_editTx8);
	DDX_Control(pDX, IDC_EBOXTX7, m_editTx7);
	DDX_Control(pDX, IDC_EBOXTX6, m_editTx6);
	DDX_Control(pDX, IDC_EBOXTX5, m_editTx5);
	DDX_Control(pDX, IDC_EBOXRX8, m_editRx8);
	DDX_Control(pDX, IDC_EBOXRX7, m_editRx7);
	DDX_Control(pDX, IDC_EBOXRX6, m_editRx6);
	DDX_Control(pDX, IDC_EBOXRX5, m_editRx5);
	DDX_Control(pDX, IDC_STOP4, m_buttonStop4);
	DDX_Control(pDX, IDC_STOP3, m_buttonStop3);
	DDX_Control(pDX, IDC_RUN4, m_buttonRun4);
	DDX_Control(pDX, IDC_RUN3, m_buttonRun3);
	DDX_Control(pDX, IDC_LOOPTEST4, m_checkLoopTest4);
	DDX_Control(pDX, IDC_LOOPTEST3, m_checkLoopTest3);
	DDX_Control(pDX, IDC_EBOXTX4, m_editTx4);
	DDX_Control(pDX, IDC_EBOXTX3, m_editTx3);
	DDX_Control(pDX, IDC_EBOXRX4, m_editRx4);
	DDX_Control(pDX, IDC_EBOXRX3, m_editRx3);
	DDX_Control(pDX, IDC_LOOPTEST2, m_checkLoopTest2);
	DDX_Control(pDX, IDC_STOP2, m_buttonStop2);
	DDX_Control(pDX, IDC_EBOXTX2, m_editTx2);
	DDX_Control(pDX, IDC_EBOXRX2, m_editRx2);
	DDX_Control(pDX, IDC_RUN2, m_buttonRun2);
	DDX_Control(pDX, IDC_TRANSFER8, m_buttonTransfer8);
	DDX_Control(pDX, IDC_TRANSFER7, m_buttonTransfer7);
	DDX_Control(pDX, IDC_TRANSFER6, m_buttonTransfer6);
	DDX_Control(pDX, IDC_TRANSFER5, m_buttonTransfer5);
	DDX_Control(pDX, IDC_TRANSFER4, m_buttonTransfer4);
	DDX_Control(pDX, IDC_TRANSFER3, m_buttonTransfer3);
	DDX_Control(pDX, IDC_TRANSFER2, m_buttonTransfer2);
	DDX_Control(pDX, IDC_EBOXTX1, m_editTx1);
	DDX_Control(pDX, IDC_EBOXRX1, m_editRx1);
	DDX_Control(pDX, IDC_LOOPTEST1, m_checkLoopTest1);
	DDX_Control(pDX, IDC_TRANSFER1, m_buttonTransfer1);
	DDX_Control(pDX, IDC_STOP1, m_buttonStop1);
	DDX_Control(pDX, IDC_RUN1, m_buttonRun1);
	DDX_Control(pDX, IDC_DATAERRCHECK1, m_checkDataErrorCheckONOFF1);
	DDX_Control(pDX, IDC_DATAERRCHECK2, m_checkDataErrorCheckONOFF2);
	DDX_Control(pDX, IDC_DATAERRCHECK3, m_checkDataErrorCheckONOFF3);
	DDX_Control(pDX, IDC_DATAERRCHECK4, m_checkDataErrorCheckONOFF4);
	DDX_Control(pDX, IDC_DATAERRCHECK5, m_checkDataErrorCheckONOFF5);
	DDX_Control(pDX, IDC_DATAERRCHECK6, m_checkDataErrorCheckONOFF6);
	DDX_Control(pDX, IDC_DATAERRCHECK7, m_checkDataErrorCheckONOFF7);
	DDX_Control(pDX, IDC_DATAERRCHECK8, m_checkDataErrorCheckONOFF8);
	DDX_Text(pDX, IDC_EDIT_READ1, m_ReadData1);
	DDX_Text(pDX, IDC_EDIT_READ2, m_ReadData2);
	DDX_Text(pDX, IDC_EDIT_READ3, m_ReadData3);
	DDX_Text(pDX, IDC_EDIT_READ4, m_ReadData4);
	DDX_Text(pDX, IDC_EDIT_READ5, m_ReadData5);
	DDX_Text(pDX, IDC_EDIT_READ6, m_ReadData6);
	DDX_Text(pDX, IDC_EDIT_READ7, m_ReadData7);
	DDX_Text(pDX, IDC_EDIT_READ8, m_ReadData8);
	DDX_Text(pDX, IDC_EDIT_WRITE1, m_WriteData1);
	DDV_MaxChars(pDX, m_WriteData1, 4);
	DDX_Text(pDX, IDC_EDIT_WRITE2, m_WriteData2);
	DDV_MaxChars(pDX, m_WriteData2, 4);
	DDX_Text(pDX, IDC_EDIT_WRITE3, m_WriteData3);
	DDV_MaxChars(pDX, m_WriteData3, 4);
	DDX_Text(pDX, IDC_EDIT_WRITE4, m_WriteData4);
	DDV_MaxChars(pDX, m_WriteData4, 4);
	DDX_Text(pDX, IDC_EDIT_WRITE5, m_WriteData5);
	DDV_MaxChars(pDX, m_WriteData5, 4);
	DDX_Text(pDX, IDC_EDIT_WRITE6, m_WriteData6);
	DDV_MaxChars(pDX, m_WriteData6, 4);
	DDX_Text(pDX, IDC_EDIT_WRITE7, m_WriteData7);
	DDV_MaxChars(pDX, m_WriteData7, 4);
	DDX_Text(pDX, IDC_EDIT_WRITE8, m_WriteData8);
	DDV_MaxChars(pDX, m_WriteData8, 4);
	DDX_Text(pDX, IDC_EDIT_CFG_WRITE, m_CfgWriteData);
	DDV_MaxChars(pDX, m_CfgWriteData, 4);
	DDX_Text(pDX, IDC_EDIT_CFG_READ, m_CfgReadData);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSerialCommTestDlg, CScrollDialog)
	//{{AFX_MSG_MAP(CSerialCommTestDlg)
	ON_BN_CLICKED(IDC_TRANSFER1, OnTransfer1)
	ON_BN_CLICKED(IDC_RUN1, OnRun1)
	ON_EN_MAXTEXT(IDC_EBOXTX1, OnMaxtextTx1)
	ON_EN_MAXTEXT(IDC_EBOXRX1, OnMaxtextRx1)
	ON_BN_CLICKED(IDC_TRANSFER2, OnTransfer2)
	ON_BN_CLICKED(IDC_TRANSFER3, OnTransfer3)
	ON_BN_CLICKED(IDC_TRANSFER4, OnTransfer4)
	ON_BN_CLICKED(IDC_TRANSFER5, OnTransfer5)
	ON_BN_CLICKED(IDC_TRANSFER6, OnTransfer6)
	ON_BN_CLICKED(IDC_TRANSFER7, OnTransfer7)
	ON_BN_CLICKED(IDC_TRANSFER8, OnTransfer8)
	ON_BN_CLICKED(IDC_STOP1, OnStop1)
	ON_BN_CLICKED(IDC_RUN2, OnRun2)
	ON_BN_CLICKED(IDC_STOP2, OnStop2)
	ON_EN_MAXTEXT(IDC_EBOXTX2, OnMaxtextTx2)
	ON_EN_MAXTEXT(IDC_EBOXRX2, OnMaxtextRx2)
	ON_EN_MAXTEXT(IDC_EBOXRX3, OnMaxtextRx3)
	ON_EN_MAXTEXT(IDC_EBOXRX4, OnMaxtextRx4)
	ON_EN_MAXTEXT(IDC_EBOXTX3, OnMaxtextTx3)
	ON_EN_MAXTEXT(IDC_EBOXTX4, OnMaxtextTx4)
	ON_BN_CLICKED(IDC_STOP3, OnStop3)
	ON_BN_CLICKED(IDC_STOP4, OnStop4)
	ON_BN_CLICKED(IDC_RUN3, OnRun3)
	ON_BN_CLICKED(IDC_RUN4, OnRun4)
	ON_BN_CLICKED(IDC_RUN5, OnRun5)
	ON_BN_CLICKED(IDC_RUN6, OnRun6)
	ON_BN_CLICKED(IDC_RUN7, OnRun7)
	ON_BN_CLICKED(IDC_RUN8, OnRun8)
	ON_BN_CLICKED(IDC_STOP5, OnStop5)
	ON_BN_CLICKED(IDC_STOP6, OnStop6)
	ON_BN_CLICKED(IDC_STOP7, OnStop7)
	ON_BN_CLICKED(IDC_STOP8, OnStop8)
	ON_EN_MAXTEXT(IDC_EBOXRX5, OnMaxtextRx5)
	ON_EN_MAXTEXT(IDC_EBOXRX6, OnMaxtextRx6)
	ON_EN_MAXTEXT(IDC_EBOXRX7, OnMaxtextRx7)
	ON_EN_MAXTEXT(IDC_EBOXRX8, OnMaxtextRx8)
	ON_EN_MAXTEXT(IDC_EBOXTX5, OnMaxtextTx5)
	ON_EN_MAXTEXT(IDC_EBOXTX6, OnMaxtextTx6)
	ON_EN_MAXTEXT(IDC_EBOXTX7, OnMaxtextTx7)
	ON_EN_MAXTEXT(IDC_EBOXTX8, OnMaxtextTx8)
	ON_BN_CLICKED(IDC_LOOPTEST1, OnLooptest1)
	ON_BN_CLICKED(IDC_LOOPTEST2, OnLooptest2)
	ON_BN_CLICKED(IDC_LOOPTEST3, OnLooptest3)
	ON_BN_CLICKED(IDC_LOOPTEST4, OnLooptest4)
	ON_BN_CLICKED(IDC_LOOPTEST5, OnLooptest5)
	ON_BN_CLICKED(IDC_LOOPTEST6, OnLooptest6)
	ON_BN_CLICKED(IDC_LOOPTEST7, OnLooptest7)
	ON_BN_CLICKED(IDC_LOOPTEST8, OnLooptest8)
	ON_BN_CLICKED(IDC_WRITE_BUTTON1, OnWriteButton1)
	ON_BN_CLICKED(IDC_WRITE_BUTTON2, OnWriteButton2)
	ON_BN_CLICKED(IDC_WRITE_BUTTON3, OnWriteButton3)
	ON_BN_CLICKED(IDC_WRITE_BUTTON4, OnWriteButton4)
	ON_BN_CLICKED(IDC_WRITE_BUTTON5, OnWriteButton5)
	ON_BN_CLICKED(IDC_WRITE_BUTTON6, OnWriteButton6)
	ON_BN_CLICKED(IDC_WRITE_BUTTON7, OnWriteButton7)
	ON_BN_CLICKED(IDC_WRITE_BUTTON8, OnWriteButton8)
	ON_BN_CLICKED(IDC_READ_BUTTON1, OnReadButton1)
	ON_BN_CLICKED(IDC_READ_BUTTON2, OnReadButton2)
	ON_BN_CLICKED(IDC_READ_BUTTON3, OnReadButton3)
	ON_BN_CLICKED(IDC_READ_BUTTON4, OnReadButton4)
	ON_BN_CLICKED(IDC_READ_BUTTON5, OnReadButton5)
	ON_BN_CLICKED(IDC_READ_BUTTON6, OnReadButton6)
	ON_BN_CLICKED(IDC_READ_BUTTON7, OnReadButton7)
	ON_BN_CLICKED(IDC_READ_BUTTON8, OnReadButton8)
	ON_BN_CLICKED(IDC_CFG_WRITE_BUTTON, OnCfgWriteButton)
	ON_BN_CLICKED(IDC_CFG_READ_BUTTON, OnCfgReadButton)
	ON_CBN_CLOSEUP(IDC_COMBO_CONFIG_REG, OnCloseupComboConfigReg)
	ON_CBN_DROPDOWN(IDC_COMBO_CONFIG_REG, OnDropdownComboConfigReg)
	ON_BN_CLICKED(IDC_BUTTON_INDUCEERR1, OnButtonInduceerr1)
	ON_BN_CLICKED(IDC_BUTTON_INDUCEERR2, OnButtonInduceerr2)
	ON_BN_CLICKED(IDC_BUTTON_INDUCEERR3, OnButtonInduceerr3)
	ON_BN_CLICKED(IDC_BUTTON_INDUCEERR4, OnButtonInduceerr4)
	ON_BN_CLICKED(IDC_BUTTON_INDUCEERR5, OnButtonInduceerr5)
	ON_BN_CLICKED(IDC_BUTTON_INDUCEERR6, OnButtonInduceerr6)
	ON_BN_CLICKED(IDC_BUTTON_INDUCEERR7, OnButtonInduceerr7)
	ON_BN_CLICKED(IDC_BUTTON_INDUCEERR8, OnButtonInduceerr8)
	ON_BN_CLICKED(IDC_BUTTON_RUN_ALL, OnButtonRunAll)
	ON_BN_CLICKED(IDC_BUTTON_STOP_ALL, OnButtonStopAll)
	ON_BN_CLICKED(IDC_BUTTON_SLEEP_ALL, OnButtonSleepAll)
	ON_BN_CLICKED(IDC_BUTTON_WAKE_ALL, OnButtonWakeAll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSerialCommTestDlg message handlers

void CSerialCommTestDlg::OnClose() 
{
	//get all the new values so that we can put them in the registry
	//set all the controls with the stored values

	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();

	for(int m=0;m<MAXPORTS;m++)
		if(pApp->m_structPort.bPortOpenFlag[m])//if port is opened successfully
				m_ParTest[m].bTestStop=TRUE;
		
	pApp->m_TestDlg[0].nLoopTest=m_checkLoopTest1.GetCheck();
	pApp->m_TestDlg[0].nDisONOFF=m_checkDisONOFF1.GetCheck();
	pApp->m_TestDlg[0].nStopError=m_radioStopError1.GetCheck();
	pApp->m_TestDlg[0].nStopTime=m_radioStopTime1.GetCheck();
	pApp->m_TestDlg[0].nTestForever=m_radioForever1.GetCheck();
	m_editHrTime1.GetWindowText(pApp->m_TestDlg[0].strHrTime);
	m_editMinTime1.GetWindowText(pApp->m_TestDlg[0].strMinTime);
	
	pApp->m_TestDlg[1].nLoopTest=m_checkLoopTest2.GetCheck();
	pApp->m_TestDlg[1].nDisONOFF=m_checkDisONOFF2.GetCheck();
	pApp->m_TestDlg[1].nStopError=m_radioStopError2.GetCheck();
	pApp->m_TestDlg[1].nStopTime=m_radioStopTime2.GetCheck();
	pApp->m_TestDlg[1].nTestForever=m_radioForever2.GetCheck();
	m_editHrTime2.GetWindowText(pApp->m_TestDlg[1].strHrTime);
	m_editMinTime2.GetWindowText(pApp->m_TestDlg[1].strMinTime);
	
	pApp->m_TestDlg[2].nLoopTest=m_checkLoopTest3.GetCheck();
	pApp->m_TestDlg[2].nDisONOFF=m_checkDisONOFF3.GetCheck();
	pApp->m_TestDlg[2].nStopError=m_radioStopError3.GetCheck();
	pApp->m_TestDlg[2].nStopTime=m_radioStopTime3.GetCheck();
	pApp->m_TestDlg[2].nTestForever=m_radioForever3.GetCheck();
	m_editHrTime3.GetWindowText(pApp->m_TestDlg[2].strHrTime);
	m_editMinTime3.GetWindowText(pApp->m_TestDlg[2].strMinTime);
	

	pApp->m_TestDlg[3].nLoopTest=m_checkLoopTest4.GetCheck();
	pApp->m_TestDlg[3].nDisONOFF=m_checkDisONOFF4.GetCheck();
	pApp->m_TestDlg[3].nStopError=m_radioStopError4.GetCheck();
	pApp->m_TestDlg[3].nStopTime=m_radioStopTime4.GetCheck();
	pApp->m_TestDlg[3].nTestForever=m_radioForever4.GetCheck();
	m_editHrTime4.GetWindowText(pApp->m_TestDlg[3].strHrTime);
	m_editMinTime4.GetWindowText(pApp->m_TestDlg[3].strMinTime);

	pApp->m_TestDlg[4].nLoopTest=m_checkLoopTest5.GetCheck();
	pApp->m_TestDlg[4].nDisONOFF=m_checkDisONOFF5.GetCheck();
	pApp->m_TestDlg[4].nStopError=m_radioStopError5.GetCheck();
	pApp->m_TestDlg[4].nStopTime=m_radioStopTime5.GetCheck();
	pApp->m_TestDlg[4].nTestForever=m_radioForever5.GetCheck();
	m_editHrTime5.GetWindowText(pApp->m_TestDlg[4].strHrTime);
	m_editMinTime5.SetWindowText(pApp->m_TestDlg[4].strMinTime);
	
	pApp->m_TestDlg[5].nLoopTest=m_checkLoopTest6.GetCheck();
	pApp->m_TestDlg[5].nDisONOFF=m_checkDisONOFF6.GetCheck();
	pApp->m_TestDlg[5].nStopError=m_radioStopError6.GetCheck();
	pApp->m_TestDlg[5].nStopTime=m_radioStopTime6.GetCheck();
	pApp->m_TestDlg[5].nTestForever=m_radioForever6.GetCheck();
	m_editHrTime6.GetWindowText(pApp->m_TestDlg[5].strHrTime);
	m_editMinTime6.GetWindowText(pApp->m_TestDlg[5].strMinTime);
	
	pApp->m_TestDlg[6].nLoopTest=m_checkLoopTest7.GetCheck();
	pApp->m_TestDlg[6].nDisONOFF=m_checkDisONOFF7.GetCheck();
	pApp->m_TestDlg[6].nStopError=m_radioStopError7.GetCheck();
	pApp->m_TestDlg[6].nStopTime=m_radioStopTime7.GetCheck();
	pApp->m_TestDlg[6].nTestForever=m_radioForever7.GetCheck();
	m_editHrTime7.GetWindowText(pApp->m_TestDlg[6].strHrTime);
	m_editMinTime7.GetWindowText(pApp->m_TestDlg[6].strMinTime);
	
	pApp->m_TestDlg[7].nLoopTest=m_checkLoopTest8.GetCheck();
	pApp->m_TestDlg[7].nDisONOFF=m_checkDisONOFF8.GetCheck();
	pApp->m_TestDlg[7].nStopError=m_radioStopError8.GetCheck();
	pApp->m_TestDlg[7].nStopTime=m_radioStopTime8.GetCheck();
	pApp->m_TestDlg[7].nTestForever=m_radioForever8.GetCheck();
	m_editHrTime8.GetWindowText(pApp->m_TestDlg[7].strHrTime);
	m_editMinTime8.GetWindowText(pApp->m_TestDlg[7].strMinTime);

	DestroyWindow();	
	
}

void CSerialCommTestDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	
}

void CSerialCommTestDlg::PostNcDestroy() 
{
	DestroyWindow();	
	m_pSerialCommTestDlg=NULL;
	delete this;
	
}

void CSerialCommTestDlg::OnTransfer1() 
{
	//this function is invoked when the user presses the Transfer button of Port1.
	//Data selection dialog is poped up

	CUserDataDlg dlg(1);
	CString StrdlgError;
	StrdlgError = "Unable to Open User Defined Data Dialog";
	int nRet=dlg.DoModal();// creating the  dialog box
	if((nRet == IDABORT)||(nRet==(-1)))// if the function fails
		AfxGetMainWnd()->MessageBox(StrdlgError,"Error",MB_OK|MB_ICONEXCLAMATION);		
}

BOOL CSerialCommTestDlg::OnInitDialog() 
{
	//SerialCommTestDlg is derived from CScrollDialog
	//all the controls are set to the stored variables

	CScrollDialog::OnInitDialog();

	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
		
	m_checkLoopTest1.SetCheck(0);//pApp->m_TestDlg[0].nLoopTest);
	//m_checkDisONOFF1.SetCheck(pApp->m_TestDlg[0].nDisONOFF);
	m_checkDisONOFF1.SetCheck(pApp->m_structPort.bPortOpenFlag[0]);	
	m_radioStopError1.SetCheck(pApp->m_TestDlg[0].nStopError);
	m_radioStopTime1.SetCheck(pApp->m_TestDlg[0].nStopTime);
	m_radioForever1.SetCheck(pApp->m_TestDlg[0].nTestForever);
	m_editHrTime1.SetWindowText(pApp->m_TestDlg[0].strHrTime);
	m_editMinTime1.SetWindowText(pApp->m_TestDlg[0].strMinTime);
	m_editTx1.SetWindowText(pApp->m_TestDlg[0].strTx);
	m_editRx1.SetWindowText(pApp->m_TestDlg[0].strRx);

	m_checkLoopTest2.SetCheck(0);//pApp->m_TestDlg[1].nLoopTest);
	//m_checkDisONOFF2.SetCheck(pApp->m_TestDlg[1].nDisONOFF);
	m_checkDisONOFF2.SetCheck(pApp->m_structPort.bPortOpenFlag[1]);
	m_radioStopError2.SetCheck(pApp->m_TestDlg[1].nStopError);
	m_radioStopTime2.SetCheck(pApp->m_TestDlg[1].nStopTime);
	m_radioForever2.SetCheck(pApp->m_TestDlg[1].nTestForever);
	m_editHrTime2.SetWindowText(pApp->m_TestDlg[1].strHrTime);
	m_editMinTime2.SetWindowText(pApp->m_TestDlg[1].strMinTime);
	m_editTx2.SetWindowText(pApp->m_TestDlg[1].strTx);
	m_editRx2.SetWindowText(pApp->m_TestDlg[1].strRx);

	m_checkLoopTest3.SetCheck(0);//pApp->m_TestDlg[2].nLoopTest);
	//m_checkDisONOFF3.SetCheck(pApp->m_TestDlg[2].nDisONOFF);
	m_checkDisONOFF3.SetCheck(pApp->m_structPort.bPortOpenFlag[2]);
	m_radioStopError3.SetCheck(pApp->m_TestDlg[2].nStopError);
	m_radioStopTime3.SetCheck(pApp->m_TestDlg[2].nStopTime);
	m_radioForever3.SetCheck(pApp->m_TestDlg[2].nTestForever);
	m_editHrTime3.SetWindowText(pApp->m_TestDlg[2].strHrTime);
	m_editMinTime3.SetWindowText(pApp->m_TestDlg[2].strMinTime);
	m_editTx3.SetWindowText(pApp->m_TestDlg[2].strTx);
	m_editRx3.SetWindowText(pApp->m_TestDlg[2].strRx);

	m_checkLoopTest4.SetCheck(0);//pApp->m_TestDlg[3].nLoopTest);
	//m_checkDisONOFF4.SetCheck(pApp->m_TestDlg[3].nDisONOFF);
	m_checkDisONOFF4.SetCheck(pApp->m_structPort.bPortOpenFlag[3]);
	m_radioStopError4.SetCheck(pApp->m_TestDlg[3].nStopError);
	m_radioStopTime4.SetCheck(pApp->m_TestDlg[3].nStopTime);
	m_radioForever4.SetCheck(pApp->m_TestDlg[3].nTestForever);
	m_editHrTime4.SetWindowText(pApp->m_TestDlg[3].strHrTime);
	m_editMinTime4.SetWindowText(pApp->m_TestDlg[3].strMinTime);
	m_editTx4.SetWindowText(pApp->m_TestDlg[3].strTx);
	m_editRx4.SetWindowText(pApp->m_TestDlg[3].strRx);

	m_checkLoopTest5.SetCheck(0);//pApp->m_TestDlg[4].nLoopTest);
	//m_checkDisONOFF5.SetCheck(pApp->m_TestDlg[4].nDisONOFF);
	m_checkDisONOFF5.SetCheck(pApp->m_structPort.bPortOpenFlag[4]);
	m_radioStopError5.SetCheck(pApp->m_TestDlg[4].nStopError);
	m_radioStopTime5.SetCheck(pApp->m_TestDlg[4].nStopTime);
	m_radioForever5.SetCheck(pApp->m_TestDlg[4].nTestForever);
	m_editHrTime5.SetWindowText(pApp->m_TestDlg[4].strHrTime);
	m_editMinTime5.SetWindowText(pApp->m_TestDlg[4].strMinTime);
	m_editTx5.SetWindowText(pApp->m_TestDlg[4].strTx);
	m_editRx5.SetWindowText(pApp->m_TestDlg[4].strRx);

	m_checkLoopTest6.SetCheck(0);//pApp->m_TestDlg[5].nLoopTest);
	//m_checkDisONOFF6.SetCheck(pApp->m_TestDlg[5].nDisONOFF);
	m_checkDisONOFF6.SetCheck(pApp->m_structPort.bPortOpenFlag[5]);
	m_radioStopError6.SetCheck(pApp->m_TestDlg[5].nStopError);
	m_radioStopTime6.SetCheck(pApp->m_TestDlg[5].nStopTime);
	m_radioForever6.SetCheck(pApp->m_TestDlg[5].nTestForever);
	m_editHrTime6.SetWindowText(pApp->m_TestDlg[5].strHrTime);
	m_editMinTime6.SetWindowText(pApp->m_TestDlg[5].strMinTime);
	m_editTx6.SetWindowText(pApp->m_TestDlg[5].strTx);
	m_editRx6.SetWindowText(pApp->m_TestDlg[5].strRx);

	m_checkLoopTest7.SetCheck(0);//pApp->m_TestDlg[6].nLoopTest);
	//m_checkDisONOFF7.SetCheck(pApp->m_TestDlg[6].nDisONOFF);
	m_checkDisONOFF7.SetCheck(pApp->m_structPort.bPortOpenFlag[6]);
	m_radioStopError7.SetCheck(pApp->m_TestDlg[6].nStopError);
	m_radioStopTime7.SetCheck(pApp->m_TestDlg[6].nStopTime);
	m_radioForever7.SetCheck(pApp->m_TestDlg[6].nTestForever);
	m_editHrTime7.SetWindowText(pApp->m_TestDlg[6].strHrTime);
	m_editMinTime7.SetWindowText(pApp->m_TestDlg[6].strMinTime);
	m_editTx7.SetWindowText(pApp->m_TestDlg[6].strTx);
	m_editRx7.SetWindowText(pApp->m_TestDlg[6].strRx);

	m_checkLoopTest8.SetCheck(0);//pApp->m_TestDlg[7].nLoopTest);
	//m_checkDisONOFF8.SetCheck(pApp->m_TestDlg[7].nDisONOFF);
	m_checkDisONOFF8.SetCheck(pApp->m_structPort.bPortOpenFlag[7]);
	m_radioStopError8.SetCheck(pApp->m_TestDlg[7].nStopError);
	m_radioStopTime8.SetCheck(pApp->m_TestDlg[7].nStopTime);
	m_radioForever8.SetCheck(pApp->m_TestDlg[7].nTestForever);
	m_editHrTime8.SetWindowText(pApp->m_TestDlg[7].strHrTime);
	m_editMinTime8.SetWindowText(pApp->m_TestDlg[7].strMinTime);
	m_editTx8.SetWindowText(pApp->m_TestDlg[7].strTx);
	m_editRx8.SetWindowText(pApp->m_TestDlg[7].strRx);

	m_editTx1.SetLimitText(10000);//limit the number of bytes in the edit box to 10000
	m_editRx1.SetLimitText(10000);
	m_editTx2.SetLimitText(10000);
	m_editRx2.SetLimitText(10000);
	m_editTx3.SetLimitText(10000);
	m_editRx3.SetLimitText(10000);
	m_editTx4.SetLimitText(10000);
	m_editRx4.SetLimitText(10000);
	m_editTx5.SetLimitText(10000);
	m_editRx5.SetLimitText(10000);
	m_editTx6.SetLimitText(10000);
	m_editRx6.SetLimitText(10000);
	m_editTx7.SetLimitText(10000);
	m_editRx7.SetLimitText(10000);
	m_editTx8.SetLimitText(10000);
	m_editRx8.SetLimitText(10000);

	m_editPacCount1.SetWindowText("0");//reset the display error
	m_editPacCount2.SetWindowText("0");//reset the display error
	m_editPacCount3.SetWindowText("0");//reset the display error
	m_editPacCount4.SetWindowText("0");//reset the display error
	m_editPacCount5.SetWindowText("0");//reset the display error
	m_editPacCount6.SetWindowText("0");//reset the display error
	m_editPacCount7.SetWindowText("0");//reset the display error
	m_editPacCount8.SetWindowText("0");//reset the display error

	if(pApp->m_TestDlg[0].nStopTime)//if user data radio button is checked
	{
		m_editHrTime1.EnableWindow(TRUE);
		m_editMinTime1.EnableWindow(TRUE);
	}
	else
	{
		m_editHrTime1.EnableWindow(FALSE);
		m_editMinTime1.EnableWindow(FALSE);
	}

	if(pApp->m_TestDlg[1].nStopTime)//if user data radio button is checked
	{
		m_editHrTime2.EnableWindow(TRUE);
		m_editMinTime2.EnableWindow(TRUE);
	}
	else
	{
		m_editHrTime2.EnableWindow(FALSE);
		m_editMinTime2.EnableWindow(FALSE);
	}

	if(pApp->m_TestDlg[2].nStopTime)//if user data radio button is checked
	{
		m_editHrTime3.EnableWindow(TRUE);
		m_editMinTime3.EnableWindow(TRUE);
	}
	else
	{
		m_editHrTime3.EnableWindow(FALSE);
		m_editMinTime3.EnableWindow(FALSE);
	}

	if(pApp->m_TestDlg[3].nStopTime)//if user data radio button is checked
	{
		m_editHrTime4.EnableWindow(TRUE);
		m_editMinTime4.EnableWindow(TRUE);
	}
	else
	{
		m_editHrTime4.EnableWindow(FALSE);
		m_editMinTime4.EnableWindow(FALSE);
	}

	if(pApp->m_TestDlg[4].nStopTime)//if user data radio button is checked
	{
		m_editHrTime5.EnableWindow(TRUE);
		m_editMinTime5.EnableWindow(TRUE);
	}
	else
	{
		m_editHrTime5.EnableWindow(FALSE);
		m_editMinTime5.EnableWindow(FALSE);
	}

	if(pApp->m_TestDlg[5].nStopTime)//if user data radio button is checked
	{
		m_editHrTime6.EnableWindow(TRUE);
		m_editMinTime6.EnableWindow(TRUE);
	}
	else
	{
		m_editHrTime6.EnableWindow(FALSE);
		m_editMinTime6.EnableWindow(FALSE);
	}
	
	if(pApp->m_TestDlg[6].nStopTime)//if user data radio button is checked
	{
		m_editHrTime7.EnableWindow(TRUE);
		m_editMinTime7.EnableWindow(TRUE);
	}
	else
	{
		m_editHrTime7.EnableWindow(FALSE);
		m_editMinTime7.EnableWindow(FALSE);
	}

	if(pApp->m_TestDlg[7].nStopTime)//if user data radio button is checked
	{
		m_editHrTime8.EnableWindow(TRUE);
		m_editMinTime8.EnableWindow(TRUE);
	}
	else
	{
		m_editHrTime8.EnableWindow(FALSE);
		m_editMinTime8.EnableWindow(FALSE);
	}
	
	m_buttonStop1.EnableWindow(FALSE);
	m_buttonStop2.EnableWindow(FALSE);
	m_buttonStop3.EnableWindow(FALSE);
	m_buttonStop4.EnableWindow(FALSE);
	m_buttonStop5.EnableWindow(FALSE);
	m_buttonStop6.EnableWindow(FALSE);
	m_buttonStop7.EnableWindow(FALSE);
	m_buttonStop8.EnableWindow(FALSE);

	m_buttonInduceErr1.EnableWindow(FALSE);
	m_buttonInduceErr2.EnableWindow(FALSE);
	m_buttonInduceErr3.EnableWindow(FALSE);
	m_buttonInduceErr4.EnableWindow(FALSE);
	m_buttonInduceErr5.EnableWindow(FALSE);
	m_buttonInduceErr6.EnableWindow(FALSE);
	m_buttonInduceErr7.EnableWindow(FALSE);
	m_buttonInduceErr8.EnableWindow(FALSE);

	//regset read/write
	CComboBox* pCfgRegListBox;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG1);
	pCfgRegListBox->SetCurSel(0);
	pCfgRegListBox = NULL;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG2);
	pCfgRegListBox->SetCurSel(0);
	pCfgRegListBox = NULL;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG3);
	pCfgRegListBox->SetCurSel(0);
	pCfgRegListBox = NULL;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG4);
	pCfgRegListBox->SetCurSel(0);
	pCfgRegListBox = NULL;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG5);
	pCfgRegListBox->SetCurSel(0);
	pCfgRegListBox = NULL;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG6);
	pCfgRegListBox->SetCurSel(0);
	pCfgRegListBox = NULL;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG7);
	pCfgRegListBox->SetCurSel(0);
	pCfgRegListBox = NULL;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG8);
	pCfgRegListBox->SetCurSel(0);
	pCfgRegListBox = NULL;


	m_WriteData1 = "0x00";
	m_WriteData2 = "0x00";
	m_WriteData3 = "0x00";
	m_WriteData4 = "0x00";
	m_WriteData5 = "0x00";
	m_WriteData6 = "0x00";
	m_WriteData7 = "0x00";
	m_WriteData8 = "0x00";

	CComboBox* pCfgRegComboBox;
	pCfgRegComboBox = (CComboBox*)GetDlgItem(IDC_COMBO_CONFIG_REG);
	pCfgRegComboBox->SetCurSel(0);

	// 
	// since 0x80 is read-only, disable all write button related fields
	//
	CButton  *pbWrite;
	pbWrite = (CButton*)GetDlgItem(IDC_CFG_WRITE_BUTTON);
	if (pbWrite)
	{				
		pbWrite->EnableWindow(FALSE);		
	}
	m_CfgWriteData = "0x00";

	CEdit* pWriteEdit;
	pWriteEdit = (CEdit*)GetDlgItem(IDC_EDIT_CFG_WRITE);
	if (pWriteEdit)
	{				
		pWriteEdit->EnableWindow(FALSE);; 
	}

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSerialCommTestDlg::OnStoponTime1() 
{
	m_editHrTime1.EnableWindow(TRUE);	
	m_editMinTime1.EnableWindow(TRUE);	
}

void CSerialCommTestDlg::OnStoponError1() 
{
	m_editHrTime1.EnableWindow(FALSE);	
	m_editMinTime1.EnableWindow(FALSE);
	
}

void CSerialCommTestDlg::OnTestForever1() 
{
	m_editHrTime1.EnableWindow(FALSE);
	m_editMinTime1.EnableWindow(FALSE);
	
}

void CSerialCommTestDlg::OnRun1() 
{
	//when the user presses the Run button of Port1, this function is called.
	
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();

	if(pApp->m_structPort.bPortOpenFlag[0])//if the port represented by m_nPortNo was opened successfully
	{
		pApp->m_nRunCount++;
		m_ParTest[0].bTestRun=TRUE;
		m_Test.OnRun(0);	
	}
}

void CSerialCommTestDlg::OnMaxtextTx1() 
{
	m_editTx1.SetWindowText("");	
}

void CSerialCommTestDlg::OnMaxtextRx1() 
{
	//this function is called when the total number of characters in the Rx1 edit box 
	//reaches 10000 bytes

	m_editRx1.SetWindowText("");	
}

void CSerialCommTestDlg::OnTransfer2() 
{
	//this function is invoked when the user presses the Transfer button of Port2.
	//Data selection dialog is poped up

	CUserDataDlg dlg(2);
	CString StrdlgError;
	StrdlgError = "Unable to Open User Defined Data Dialog";
	int nRet=dlg.DoModal();// creating the  dialog box
	if((nRet == IDABORT)||(nRet==(-1)))// if the function fails
		AfxGetMainWnd()->MessageBox(StrdlgError,"Error",MB_OK|MB_ICONEXCLAMATION);
	
}

void CSerialCommTestDlg::OnTransfer3() 
{
	//this function is invoked when the user presses the Transfer button of Port3
	//Data selection dialog is poped up

	CUserDataDlg dlg(3);
	CString StrdlgError;
	StrdlgError = "Unable to Open User Defined Data Dialog";
	int nRet=dlg.DoModal();// creating the  dialog box
	if((nRet == IDABORT)||(nRet==(-1)))// if the function fails
		AfxGetMainWnd()->MessageBox(StrdlgError,"Error",MB_OK|MB_ICONEXCLAMATION);
	
}

void CSerialCommTestDlg::OnTransfer4() 
{
	//this function is invoked when the user presses the Transfer button of Port4
	//Data selection dialog is poped up

	CUserDataDlg dlg(4);
	CString StrdlgError;
	StrdlgError = "Unable to Open User Defined Data Dialog";
	int nRet=dlg.DoModal();// creating the  dialog box
	if((nRet == IDABORT)||(nRet==(-1)))// if the function fails
		AfxGetMainWnd()->MessageBox(StrdlgError,"Error",MB_OK|MB_ICONEXCLAMATION);
	
}

void CSerialCommTestDlg::OnTransfer5() 
{
	//this function is invoked when the user presses the Transfer button of Port5
	//Data selection dialog is poped up

	CUserDataDlg dlg(5);
	CString StrdlgError;
	StrdlgError = "Unable to Open User Defined Data Dialog";
	int nRet=dlg.DoModal();// creating the  dialog box
	if((nRet == IDABORT)||(nRet==(-1)))// if the function fails
		AfxGetMainWnd()->MessageBox(StrdlgError,"Error",MB_OK|MB_ICONEXCLAMATION);
	
}

void CSerialCommTestDlg::OnTransfer6() 
{
	//this function is invoked when the user presses the Transfer button of Port6
	//Data selection dialog is poped up

	CUserDataDlg dlg(6);
	CString StrdlgError;
	StrdlgError = "Unable to Open User Defined Data Dialog";
	int nRet=dlg.DoModal();// creating the  dialog box
	if((nRet == IDABORT)||(nRet==(-1)))// if the function fails
		AfxGetMainWnd()->MessageBox(StrdlgError,"Error",MB_OK|MB_ICONEXCLAMATION);
	
}

void CSerialCommTestDlg::OnTransfer7() 
{
	//this function is invoked when the user presses the Transfer button of Port7
	//Data selection dialog is poped up

	CUserDataDlg dlg(7);
	CString StrdlgError;
	StrdlgError = "Unable to Open User Defined Data Dialog";
	int nRet=dlg.DoModal();// creating the  dialog box
	if((nRet == IDABORT)||(nRet==(-1)))// if the function fails
		AfxGetMainWnd()->MessageBox(StrdlgError,"Error",MB_OK|MB_ICONEXCLAMATION);
	
}

void CSerialCommTestDlg::OnTransfer8() 
{
	//this function is invoked when the user presses the Transfer button of Port8
	//Data selection dialog is poped up

	CUserDataDlg dlg(8);
	CString StrdlgError;
	StrdlgError = "Unable to Open User Defined Data Dialog";
	int nRet=dlg.DoModal();// creating the  dialog box
	if((nRet == IDABORT)||(nRet==(-1)))// if the function fails
		AfxGetMainWnd()->MessageBox(StrdlgError,"Error",MB_OK|MB_ICONEXCLAMATION);
	
}

void CSerialCommTestDlg::OnStop1() 
{
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	pApp->m_nRunCount--;
	m_Test.OnStop(0);
}

void CSerialCommTestDlg::OnRun2() 
{
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();

	if(pApp->m_structPort.bPortOpenFlag[1])//if the port represented by m_nPortNo was opened successfully
	{
		pApp->m_nRunCount++;
		m_ParTest[1].bTestRun=TRUE;
		m_Test.OnRun(1);	
	}
}

void CSerialCommTestDlg::OnStop2() 
{
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	pApp->m_nRunCount--;
	m_Test.OnStop(1);	
	
}

void CSerialCommTestDlg::OnMaxtextTx2() 
{
	m_editTx2.SetWindowText("");		
}

void CSerialCommTestDlg::OnMaxtextRx2() 
{
	m_editRx2.SetWindowText("");	
	
}

void CSerialCommTestDlg::OnMaxtextRx3() 
{
	m_editRx3.SetWindowText("");
	
}

void CSerialCommTestDlg::OnMaxtextRx4() 
{
	m_editRx4.SetWindowText("");
	
}

void CSerialCommTestDlg::OnMaxtextTx3() 
{
	m_editTx3.SetWindowText("");
	
}

void CSerialCommTestDlg::OnMaxtextTx4() 
{
	m_editTx4.SetWindowText("");
	
}

void CSerialCommTestDlg::OnStop3() 
{
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	pApp->m_nRunCount--;
	m_Test.OnStop(2);	
}

void CSerialCommTestDlg::OnStop4() 
{
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	pApp->m_nRunCount--;
	m_Test.OnStop(3);	
}

void CSerialCommTestDlg::OnRun3() 
{
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();

	if(pApp->m_structPort.bPortOpenFlag[2])//if the port represented by m_nPortNo was opened successfully
	{
		pApp->m_nRunCount++;
		m_ParTest[2].bTestRun=TRUE;
		m_Test.OnRun(2);
	}
}

void CSerialCommTestDlg::OnRun4() 
{
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	
	if(pApp->m_structPort.bPortOpenFlag[3])//if the port represented by m_nPortNo was opened successfully
	{
		pApp->m_nRunCount++;	
		m_ParTest[3].bTestRun=TRUE;
		m_Test.OnRun(3);	
	}
}

void CSerialCommTestDlg::OnStoponError2() 
{
	m_editHrTime2.EnableWindow(FALSE);	
	m_editMinTime2.EnableWindow(FALSE);	
}

void CSerialCommTestDlg::OnStoponError3() 
{
	m_editHrTime3.EnableWindow(FALSE);	
	m_editMinTime3.EnableWindow(FALSE);
}

void CSerialCommTestDlg::OnStoponError4() 
{
	m_editHrTime4.EnableWindow(FALSE);	
	m_editMinTime4.EnableWindow(FALSE);
}

void CSerialCommTestDlg::OnStoponTime2() 
{
	m_editHrTime2.EnableWindow(TRUE);	
	m_editMinTime2.EnableWindow(TRUE);	
	
}

void CSerialCommTestDlg::OnStoponTime3() 
{
	m_editHrTime3.EnableWindow(TRUE);	
	m_editMinTime3.EnableWindow(TRUE);	
	
}

void CSerialCommTestDlg::OnStoponTime4() 
{
	m_editHrTime4.EnableWindow(TRUE);	
	m_editMinTime4.EnableWindow(TRUE);	
	
}

void CSerialCommTestDlg::OnTestforever2() 
{
	m_editHrTime2.EnableWindow(FALSE);
	m_editMinTime2.EnableWindow(FALSE);
	
}

void CSerialCommTestDlg::OnTestforever3() 
{
	m_editHrTime3.EnableWindow(FALSE);
	m_editMinTime3.EnableWindow(FALSE);	
}

void CSerialCommTestDlg::OnTestforever4() 
{
	m_editHrTime4.EnableWindow(FALSE);
	m_editMinTime4.EnableWindow(FALSE);	
}

void CSerialCommTestDlg::OnRun5() 
{
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();

	if(pApp->m_structPort.bPortOpenFlag[4])//if the port represented by m_nPortNo was opened successfully
	{
		pApp->m_nRunCount++;
		m_ParTest[4].bTestRun=TRUE;
		m_Test.OnRun(4);
	}

}

void CSerialCommTestDlg::OnRun6() 
{
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();

	if(pApp->m_structPort.bPortOpenFlag[5])//if the port represented by m_nPortNo was opened successfully
	{
		pApp->m_nRunCount++;
		m_ParTest[5].bTestRun=TRUE;
		m_Test.OnRun(5);
	}
}

void CSerialCommTestDlg::OnRun7() 
{
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();

	if(pApp->m_structPort.bPortOpenFlag[6])//if the port represented by m_nPortNo was opened successfully
	{
		pApp->m_nRunCount++;
		m_ParTest[6].bTestRun=TRUE;
		m_Test.OnRun(6);
	}
}

void CSerialCommTestDlg::OnRun8() 
{
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	
	if(pApp->m_structPort.bPortOpenFlag[7])//if the port represented by m_nPortNo was opened successfully
	{
		pApp->m_nRunCount++;
		m_ParTest[7].bTestRun=TRUE;
		m_Test.OnRun(7);	
	}
}

void CSerialCommTestDlg::OnStop5() 
{
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	pApp->m_nRunCount--;
	m_Test.OnStop(4);	
}

void CSerialCommTestDlg::OnStop6() 
{
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	pApp->m_nRunCount--;
	m_Test.OnStop(5);	
}

void CSerialCommTestDlg::OnStop7() 
{
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	pApp->m_nRunCount--;
	m_Test.OnStop(6);	
}

void CSerialCommTestDlg::OnStop8() 
{
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	pApp->m_nRunCount--;
	m_Test.OnStop(7);	
}

void CSerialCommTestDlg::OnStoponError5() 
{
	m_editHrTime5.EnableWindow(FALSE);	
	m_editMinTime5.EnableWindow(FALSE);
	
}

void CSerialCommTestDlg::OnStoponError6() 
{
	m_editHrTime6.EnableWindow(FALSE);	
	m_editMinTime6.EnableWindow(FALSE);
	
}

void CSerialCommTestDlg::OnStoponError7() 
{
	m_editHrTime7.EnableWindow(FALSE);	
	m_editMinTime7.EnableWindow(FALSE);
	
}

void CSerialCommTestDlg::OnStoponError8() 
{
	m_editHrTime8.EnableWindow(FALSE);	
	m_editMinTime8.EnableWindow(FALSE);
	
}

void CSerialCommTestDlg::OnTestForever5() 
{
	m_editHrTime5.EnableWindow(FALSE);
	m_editMinTime5.EnableWindow(FALSE);
	
}

void CSerialCommTestDlg::OnTestForever6() 
{
	m_editHrTime6.EnableWindow(FALSE);
	m_editMinTime6.EnableWindow(FALSE);
	
}

void CSerialCommTestDlg::OnTestForever7() 
{
	m_editHrTime7.EnableWindow(FALSE);
	m_editMinTime7.EnableWindow(FALSE);
	
}

void CSerialCommTestDlg::OnTestForever8() 
{
	m_editHrTime8.EnableWindow(FALSE);
	m_editMinTime8.EnableWindow(FALSE);
	
}

void CSerialCommTestDlg::OnStoponTime5() 
{
	m_editHrTime5.EnableWindow(TRUE);	
	m_editMinTime5.EnableWindow(TRUE);	
	
}

void CSerialCommTestDlg::OnStoponTime6() 
{
	m_editHrTime6.EnableWindow(TRUE);	
	m_editMinTime6.EnableWindow(TRUE);	
	
}

void CSerialCommTestDlg::OnStoponTime7() 
{
	m_editHrTime7.EnableWindow(TRUE);	
	m_editMinTime7.EnableWindow(TRUE);	
	
}

void CSerialCommTestDlg::OnStoponTime8() 
{
	m_editHrTime8.EnableWindow(TRUE);	
	m_editMinTime8.EnableWindow(TRUE);	
	
}

void CSerialCommTestDlg::OnMaxtextRx5() 
{
	m_editRx5.SetWindowText("");	
	
}

void CSerialCommTestDlg::OnMaxtextRx6() 
{
	m_editRx6.SetWindowText("");	
	
}

void CSerialCommTestDlg::OnMaxtextRx7() 
{
	m_editRx7.SetWindowText("");	
	
}

void CSerialCommTestDlg::OnMaxtextRx8() 
{
	m_editRx8.SetWindowText("");	
	
}

void CSerialCommTestDlg::OnMaxtextTx5() 
{
	m_editTx5.SetWindowText("");	
	
}

void CSerialCommTestDlg::OnMaxtextTx6() 
{
	m_editTx6.SetWindowText("");	
	
}

void CSerialCommTestDlg::OnMaxtextTx7() 
{
	m_editTx7.SetWindowText("");	
	
}

void CSerialCommTestDlg::OnMaxtextTx8() 
{
	m_editTx8.SetWindowText("");	
	
}

void CSerialCommTestDlg::OnLooptest1() //this is for the first port
{
//	COM_PORT_RW rwparm;
	COM_PORT_ENHANCED enTemp;
    DWORD  cbReturned;

	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();

	if(m_checkLoopTest1.GetCheck())//if the check box is checked
		pApp->m_TestDlg[0].nLoopTest=1;
	else
		pApp->m_TestDlg[0].nLoopTest=0;

	enTemp.LoopBack = (pApp->m_TestDlg[0].nLoopTest) ? 0x10 : 0x00;
	if (!DeviceIoControl( pApp->m_structPort.hPortHandle[0],
		(DWORD) IOCTL_XRPORT_SET_LOOP,
		&enTemp,
		sizeof(COM_PORT_ENHANCED),
		NULL,
		0,
		&cbReturned,
		0
		))
	{
			CString StrdlgError;
			StrdlgError = "Unable to set/reset Local LoopBack on port 0";
			AfxGetMainWnd()->MessageBox(StrdlgError,"Error",MB_OK|MB_ICONEXCLAMATION);		
	}

#if 0
	rwparm.RegAddr = 0x4;
	rwparm.AndVal = 0xef;
	rwparm.OrVal =  (pApp->m_TestDlg[0].nLoopTest) ? 0x10 : 0x00;
	rwparm.rw = 0x01;
	rwparm.ReadVal = 0x55;
	if (!DeviceIoControl( pApp->m_structPort.hPortHandle[0],
		(DWORD) IOCTL_XRPORT_RW,
		&rwparm,
		sizeof(COM_PORT_RW),
		NULL,
		0,
		&cbReturned,
		0
		))
	{
			CString StrdlgError;
			StrdlgError = "Unable to set/reset Local LoopBack on port 0";
			AfxGetMainWnd()->MessageBox(StrdlgError,"Error",MB_OK|MB_ICONEXCLAMATION);		
	}
#endif
}

void CSerialCommTestDlg::OnLooptest2() 
{
	COM_PORT_ENHANCED enTemp;
    DWORD  cbReturned;

	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();

	if(m_checkLoopTest2.GetCheck())//if the check box is checked
		pApp->m_TestDlg[1].nLoopTest=1;
	else
		pApp->m_TestDlg[1].nLoopTest=0;

	enTemp.LoopBack = (pApp->m_TestDlg[1].nLoopTest) ? 0x10 : 0x00;
	if (!DeviceIoControl( pApp->m_structPort.hPortHandle[1],
		(DWORD) IOCTL_XRPORT_SET_LOOP,
		&enTemp,
		sizeof(COM_PORT_ENHANCED),
		NULL,
		0,
		&cbReturned,
		0
		))
	{
			CString StrdlgError;
			StrdlgError = "Unable to set/reset Local LoopBack on port 1";
			AfxGetMainWnd()->MessageBox(StrdlgError,"Error",MB_OK|MB_ICONEXCLAMATION);		
	}
}

void CSerialCommTestDlg::OnLooptest3() 
{
	COM_PORT_ENHANCED enTemp;
    DWORD  cbReturned;

	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();

	if(m_checkLoopTest3.GetCheck())//if the check box is checked
		pApp->m_TestDlg[2].nLoopTest=1;
	else
		pApp->m_TestDlg[2].nLoopTest=0;

	enTemp.LoopBack = (pApp->m_TestDlg[2].nLoopTest) ? 0x10 : 0x00;
	if (!DeviceIoControl( pApp->m_structPort.hPortHandle[2],
		(DWORD) IOCTL_XRPORT_SET_LOOP,
		&enTemp,
		sizeof(COM_PORT_ENHANCED),
		NULL,
		0,
		&cbReturned,
		0
		))
	{
			CString StrdlgError;
			StrdlgError = "Unable to set/reset Local LoopBack on port 2";
			AfxGetMainWnd()->MessageBox(StrdlgError,"Error",MB_OK|MB_ICONEXCLAMATION);		
	}
}

void CSerialCommTestDlg::OnLooptest4() 
{
	COM_PORT_ENHANCED enTemp;
    DWORD  cbReturned;

	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();

	if(m_checkLoopTest4.GetCheck())//if the check box is checked
		pApp->m_TestDlg[3].nLoopTest=1;
	else
		pApp->m_TestDlg[3].nLoopTest=0;

	enTemp.LoopBack = (pApp->m_TestDlg[3].nLoopTest) ? 0x10 : 0x00;
	if (!DeviceIoControl( pApp->m_structPort.hPortHandle[3],
		(DWORD) IOCTL_XRPORT_SET_LOOP,
		&enTemp,
		sizeof(COM_PORT_ENHANCED),
		NULL,
		0,
		&cbReturned,
		0
		))
	{
			CString StrdlgError;
			StrdlgError = "Unable to set/reset Local LoopBack on port 3";
			AfxGetMainWnd()->MessageBox(StrdlgError,"Error",MB_OK|MB_ICONEXCLAMATION);		
	}
}

void CSerialCommTestDlg::OnLooptest5() 
{
	COM_PORT_ENHANCED enTemp;
    DWORD  cbReturned;

	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();

	if(m_checkLoopTest5.GetCheck())//if the check box is checked
		pApp->m_TestDlg[4].nLoopTest=1;
	else
		pApp->m_TestDlg[4].nLoopTest=0;

	enTemp.LoopBack = (pApp->m_TestDlg[4].nLoopTest) ? 0x10 : 0x00;
	if (!DeviceIoControl( pApp->m_structPort.hPortHandle[4],
		(DWORD) IOCTL_XRPORT_SET_LOOP,
		&enTemp,
		sizeof(COM_PORT_ENHANCED),
		NULL,
		0,
		&cbReturned,
		0
		))
	{
			CString StrdlgError;
			StrdlgError = "Unable to set/reset Local LoopBack on port 4";
			AfxGetMainWnd()->MessageBox(StrdlgError,"Error",MB_OK|MB_ICONEXCLAMATION);		
	}
}

void CSerialCommTestDlg::OnLooptest6() 
{
	COM_PORT_ENHANCED enTemp;
    DWORD  cbReturned;

	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();

	if(m_checkLoopTest6.GetCheck())//if the check box is checked
		pApp->m_TestDlg[5].nLoopTest=1;
	else
		pApp->m_TestDlg[5].nLoopTest=0;

	enTemp.LoopBack = (pApp->m_TestDlg[5].nLoopTest) ? 0x10 : 0x00;
	if (!DeviceIoControl( pApp->m_structPort.hPortHandle[5],
		(DWORD) IOCTL_XRPORT_SET_LOOP,
		&enTemp,
		sizeof(COM_PORT_ENHANCED),
		NULL,
		0,
		&cbReturned,
		0
		))
	{
			CString StrdlgError;
			StrdlgError = "Unable to set/reset Local LoopBack on port 5";
			AfxGetMainWnd()->MessageBox(StrdlgError,"Error",MB_OK|MB_ICONEXCLAMATION);		
	}
}

void CSerialCommTestDlg::OnLooptest7() 
{
	COM_PORT_ENHANCED enTemp;
    DWORD  cbReturned;

	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();

	if(m_checkLoopTest7.GetCheck())//if the check box is checked
		pApp->m_TestDlg[6].nLoopTest=1;
	else
		pApp->m_TestDlg[6].nLoopTest=0;

	enTemp.LoopBack = (pApp->m_TestDlg[6].nLoopTest) ? 0x10 : 0x00;
	if (!DeviceIoControl( pApp->m_structPort.hPortHandle[6],
		(DWORD) IOCTL_XRPORT_SET_LOOP,
		&enTemp,
		sizeof(COM_PORT_ENHANCED),
		NULL,
		0,
		&cbReturned,
		0
		))
	{
			CString StrdlgError;
			StrdlgError = "Unable to set/reset Local LoopBack on port 6";
			AfxGetMainWnd()->MessageBox(StrdlgError,"Error",MB_OK|MB_ICONEXCLAMATION);		
	}
}

void CSerialCommTestDlg::OnLooptest8() 
{
	COM_PORT_ENHANCED enTemp;
    DWORD  cbReturned;

	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();

	if(m_checkLoopTest8.GetCheck())//if the check box is checked
		pApp->m_TestDlg[7].nLoopTest=1;
	else
		pApp->m_TestDlg[7].nLoopTest=0;

	enTemp.LoopBack = (pApp->m_TestDlg[7].nLoopTest) ? 0x10 : 0x00;
	if (!DeviceIoControl( pApp->m_structPort.hPortHandle[7],
		(DWORD) IOCTL_XRPORT_SET_LOOP,
		&enTemp,
		sizeof(COM_PORT_ENHANCED),
		NULL,
		0,
		&cbReturned,
		0
		))
	{
			CString StrdlgError;
			StrdlgError = "Unable to set/reset Local LoopBack on port 7";
			AfxGetMainWnd()->MessageBox(StrdlgError,"Error",MB_OK|MB_ICONEXCLAMATION);		
	}
}

void CSerialCommTestDlg::OnWriteButton1() 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);

	CComboBox* pCfgRegListBox;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG1);
	int nCurConfigSel;
	nCurConfigSel = pCfgRegListBox->GetCurSel();
	if (nCurConfigSel < 0)
	{
		// 
		// this should not happen as the write button would be 
		// enabled only if this list has proper Write reg value
		//
		MessageBox("Please select the Register to which Data to be written...!", "Warning! Register not selected", MB_OK|MB_ICONEXCLAMATION);			
	}
	else
	{
		if ( (!m_WriteData1.GetLength()) || ! (m_WriteData1.Left(2) == ("0x")) )
		{
			MessageBox("Please input a value between 0x00 - 0xFF for write...!", "Warning! Improper value to Write", MB_OK|MB_ICONEXCLAMATION);			
			return;
		}		

		char *stopstring;
		BYTE bDataToReg = (BYTE)strtoul( m_WriteData1, &stopstring, 16 );

		WriteToUart(0, nCurConfigSel, bDataToReg);		
	}
}

void CSerialCommTestDlg::OnWriteButton2() 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);

	CComboBox* pCfgRegListBox;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG2);
	int nCurConfigSel;
	nCurConfigSel = pCfgRegListBox->GetCurSel();
	if (nCurConfigSel < 0)
	{
		// 
		// this should not happen as the write button would be 
		// enabled only if this list has proper Write reg value
		//
		MessageBox("Please select the Register to which Data to be written...!", "Warning! Register not selected", MB_OK|MB_ICONEXCLAMATION);			
	}
	else
	{
	if ( (!m_WriteData2.GetLength()) || ! (m_WriteData2.Left(2) == ("0x")) )
		{
			MessageBox("Please input a value between 0x00 - 0xFF for write...!", "Warning! Improper value to Write", MB_OK|MB_ICONEXCLAMATION);			
			return;
		}		

		char *stopstring;
		BYTE bDataToReg = (BYTE)strtoul( m_WriteData2, &stopstring, 16 );

		WriteToUart(1, nCurConfigSel, bDataToReg);
	}
}

void CSerialCommTestDlg::OnWriteButton3() 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);

	CComboBox* pCfgRegListBox;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG3);
	int nCurConfigSel;
	nCurConfigSel = pCfgRegListBox->GetCurSel();
	if (nCurConfigSel < 0)
	{
		// 
		// this should not happen as the write button would be 
		// enabled only if this list has proper Write reg value
		//
		MessageBox("Please select the Register to which Data to be written...!", "Warning! Register not selected", MB_OK|MB_ICONEXCLAMATION);			
	}
	else
	{
		if ( (!m_WriteData3.GetLength()) || ! (m_WriteData3.Left(2) == ("0x")) )
		{
			MessageBox("Please input a value between 0x00 - 0xFF for write...!", "Warning! Improper value to Write", MB_OK|MB_ICONEXCLAMATION);			
			return;
		}		

		char *stopstring;
		BYTE bDataToReg = (BYTE)strtoul( m_WriteData3, &stopstring, 16 );

		WriteToUart(2, nCurConfigSel, bDataToReg);	
	}
}

void CSerialCommTestDlg::OnWriteButton4() 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);

	CComboBox* pCfgRegListBox;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG4);
	int nCurConfigSel;
	nCurConfigSel = pCfgRegListBox->GetCurSel();
	if (nCurConfigSel < 0)
	{
		// 
		// this should not happen as the write button would be 
		// enabled only if this list has proper Write reg value
		//
		MessageBox("Please select the Register to which Data to be written...!", "Warning! Register not selected", MB_OK|MB_ICONEXCLAMATION);			
	}
	else
	{
		if ( (!m_WriteData4.GetLength()) || ! (m_WriteData4.Left(2) == ("0x")) )
		{
			MessageBox("Please input a value between 0x00 - 0xFF for write...!", "Warning! Improper value to Write", MB_OK|MB_ICONEXCLAMATION);			
			return;
		}		

		char *stopstring;
		BYTE bDataToReg = (BYTE)strtoul( m_WriteData4, &stopstring, 16 );

		WriteToUart(3, nCurConfigSel, bDataToReg);	
	}
}

void CSerialCommTestDlg::OnWriteButton5() 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);

	CComboBox* pCfgRegListBox;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG5);
	int nCurConfigSel;
	nCurConfigSel = pCfgRegListBox->GetCurSel();
	if (nCurConfigSel < 0)
	{
		// 
		// this should not happen as the write button would be 
		// enabled only if this list has proper Write reg value
		//
		MessageBox("Please select the Register to which Data to be written...!", "Warning! Register not selected", MB_OK|MB_ICONEXCLAMATION);			
	}
	else
	{
		if ( (!m_WriteData5.GetLength()) || ! (m_WriteData5.Left(2) == ("0x")) )
		{
			MessageBox("Please input a value between 0x00 - 0xFF for write...!", "Warning! Improper value to Write", MB_OK|MB_ICONEXCLAMATION);			
			return;
		}		

		char *stopstring;
		BYTE bDataToReg = (BYTE)strtoul( m_WriteData5, &stopstring, 16 );

		WriteToUart(4, nCurConfigSel, bDataToReg);	
	}
}

void CSerialCommTestDlg::OnWriteButton6() 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);

	CComboBox* pCfgRegListBox;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG6);
	int nCurConfigSel;
	nCurConfigSel = pCfgRegListBox->GetCurSel();
	if (nCurConfigSel < 0)
	{
		// 
		// this should not happen as the write button would be 
		// enabled only if this list has proper Write reg value
		//
		MessageBox("Please select the Register to which Data to be written...!", "Warning! Register not selected", MB_OK|MB_ICONEXCLAMATION);			
	}
	else
	{
		if ( (!m_WriteData6.GetLength()) || ! (m_WriteData6.Left(2) == ("0x")) )
		{
			MessageBox("Please input a value between 0x00 - 0xFF for write...!", "Warning! Improper value to Write", MB_OK|MB_ICONEXCLAMATION);			
			return;
		}		

		char *stopstring;
		BYTE bDataToReg = (BYTE)strtoul( m_WriteData6, &stopstring, 16 );

		WriteToUart(5, nCurConfigSel, bDataToReg);
	}
}

void CSerialCommTestDlg::OnWriteButton7() 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);

	CComboBox* pCfgRegListBox;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG7);
	int nCurConfigSel;
	nCurConfigSel = pCfgRegListBox->GetCurSel();
	if (nCurConfigSel < 0)
	{
		// 
		// this should not happen as the write button would be 
		// enabled only if this list has proper Write reg value
		//
		MessageBox("Please select the Register to which Data to be written...!", "Warning! Register not selected", MB_OK|MB_ICONEXCLAMATION);			
	}
	else
	{
		if ( (!m_WriteData7.GetLength()) || ! (m_WriteData7.Left(2) == ("0x")) )
		{
			MessageBox("Please input a value between 0x00 - 0xFF for write...!", "Warning! Improper value to Write", MB_OK|MB_ICONEXCLAMATION);			
			return;
		}		

		char *stopstring;
		BYTE bDataToReg = (BYTE)strtoul( m_WriteData7, &stopstring, 16 );

		WriteToUart(6, nCurConfigSel, bDataToReg);	
	}
}

void CSerialCommTestDlg::OnWriteButton8() 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);

	CComboBox* pCfgRegListBox;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG8);
	int nCurConfigSel;
	nCurConfigSel = pCfgRegListBox->GetCurSel();
	if (nCurConfigSel < 0)
	{
		// 
		// this should not happen as the write button would be 
		// enabled only if this list has proper Write reg value
		//
		MessageBox("Please select the Register to which Data to be written...!", "Warning! Register not selected", MB_OK|MB_ICONEXCLAMATION);			
	}
	else
	{
		if ( (!m_WriteData8.GetLength()) || ! (m_WriteData8.Left(2) == ("0x")) )
		{
			MessageBox("Please input a value between 0x00 - 0xFF for write...!", "Warning! Improper value to Write", MB_OK|MB_ICONEXCLAMATION);			
			return;
		}		

		char *stopstring;
		BYTE bDataToReg = (BYTE)strtoul( m_WriteData8, &stopstring, 16 );

		WriteToUart(7, nCurConfigSel, bDataToReg);	
	}
}

void CSerialCommTestDlg::OnReadButton1() 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);

	CComboBox* pCfgRegListBox;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG1);
	int nCurConfigSel;
	nCurConfigSel = pCfgRegListBox->GetCurSel();
	if (nCurConfigSel < 0)
	{
		// 
		// this should not happen as the write button would be 
		// enabled only if this list has proper Write reg value
		//
		MessageBox("Please select the Register to which Data to be written...!", "Warning! Register not selected", MB_OK|MB_ICONEXCLAMATION);			
	}
	else
	{
		CString tempStr;
		BYTE bReadData;
		if (ReadFromUart(0, nCurConfigSel, &bReadData))
		{
			tempStr.Format("%x", bReadData );
			tempStr.MakeUpper();

			m_ReadData1.Format("0x");
			m_ReadData1 += tempStr;
			UpdateData (FALSE);
		}
	}
}

void CSerialCommTestDlg::OnReadButton2() 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);

	CComboBox* pCfgRegListBox;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG2);
	int nCurConfigSel;
	nCurConfigSel = pCfgRegListBox->GetCurSel();
	if (nCurConfigSel < 0)
	{
		// 
		// this should not happen as the write button would be 
		// enabled only if this list has proper Write reg value
		//
		MessageBox("Please select the Register to which Data to be written...!", "Warning! Register not selected", MB_OK|MB_ICONEXCLAMATION);			
	}
	else
	{
		CString tempStr;
		BYTE bReadData;
		if (ReadFromUart(1, nCurConfigSel, &bReadData))
		{
			tempStr.Format("%x", bReadData );
			tempStr.MakeUpper();

			m_ReadData2.Format("0x");
			m_ReadData2 += tempStr;
			UpdateData (FALSE);
		}
	}	
}

void CSerialCommTestDlg::OnReadButton3() 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);

	CComboBox* pCfgRegListBox;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG3);
	int nCurConfigSel;
	nCurConfigSel = pCfgRegListBox->GetCurSel();
	if (nCurConfigSel < 0)
	{
		// 
		// this should not happen as the write button would be 
		// enabled only if this list has proper Write reg value
		//
		MessageBox("Please select the Register to which Data to be written...!", "Warning! Register not selected", MB_OK|MB_ICONEXCLAMATION);			
	}
	else
	{
		CString tempStr;
		BYTE bReadData;
		if (ReadFromUart(2, nCurConfigSel, &bReadData))
		{
			tempStr.Format("%x", bReadData );
			tempStr.MakeUpper();

			m_ReadData3.Format("0x");
			m_ReadData3 += tempStr;
			UpdateData (FALSE);
		}
	}
}

void CSerialCommTestDlg::OnReadButton4() 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);

	CComboBox* pCfgRegListBox;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG4);
	int nCurConfigSel;
	nCurConfigSel = pCfgRegListBox->GetCurSel();
	if (nCurConfigSel < 0)
	{
		// 
		// this should not happen as the write button would be 
		// enabled only if this list has proper Write reg value
		//
		MessageBox("Please select the Register to which Data to be written...!", "Warning! Register not selected", MB_OK|MB_ICONEXCLAMATION);			
	}
	else
	{
		CString tempStr;
		BYTE bReadData;
		if (ReadFromUart(3, nCurConfigSel, &bReadData))
		{
			tempStr.Format("%x", bReadData );
			tempStr.MakeUpper();

			m_ReadData4.Format("0x");
			m_ReadData4 += tempStr;
			UpdateData (FALSE);
		}
	}
}

void CSerialCommTestDlg::OnReadButton5() 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);

	CComboBox* pCfgRegListBox;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG5);
	int nCurConfigSel;
	nCurConfigSel = pCfgRegListBox->GetCurSel();
	if (nCurConfigSel < 0)
	{
		// 
		// this should not happen as the write button would be 
		// enabled only if this list has proper Write reg value
		//
		MessageBox("Please select the Register to which Data to be written...!", "Warning! Register not selected", MB_OK|MB_ICONEXCLAMATION);			
	}
	else
	{
		CString tempStr;
		BYTE bReadData;
		if (ReadFromUart(4, nCurConfigSel, &bReadData))
		{
			tempStr.Format("%x", bReadData );
			tempStr.MakeUpper();

			m_ReadData5.Format("0x");
			m_ReadData5 += tempStr;
			UpdateData (FALSE);
		}
	}
}

void CSerialCommTestDlg::OnReadButton6() 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);

	CComboBox* pCfgRegListBox;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG6);
	int nCurConfigSel;
	nCurConfigSel = pCfgRegListBox->GetCurSel();
	if (nCurConfigSel < 0)
	{
		// 
		// this should not happen as the write button would be 
		// enabled only if this list has proper Write reg value
		//
		MessageBox("Please select the Register to which Data to be written...!", "Warning! Register not selected", MB_OK|MB_ICONEXCLAMATION);			
	}
	else
	{
		CString tempStr;
		BYTE bReadData;
		if (ReadFromUart(5, nCurConfigSel, &bReadData))
		{
			tempStr.Format("%x", bReadData );
			tempStr.MakeUpper();

			m_ReadData6.Format("0x");
			m_ReadData6 += tempStr;
			UpdateData (FALSE);
		}
	}
}

void CSerialCommTestDlg::OnReadButton7() 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);

	CComboBox* pCfgRegListBox;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG7);
	int nCurConfigSel;
	nCurConfigSel = pCfgRegListBox->GetCurSel();
	if (nCurConfigSel < 0)
	{
		// 
		// this should not happen as the write button would be 
		// enabled only if this list has proper Write reg value
		//
		MessageBox("Please select the Register to which Data to be written...!", "Warning! Register not selected", MB_OK|MB_ICONEXCLAMATION);			
	}
	else
	{
		CString tempStr;
		BYTE bReadData;
		if (ReadFromUart(6, nCurConfigSel, &bReadData))
		{
			tempStr.Format("%x", bReadData );
			tempStr.MakeUpper();

			m_ReadData7.Format("0x");
			m_ReadData7 += tempStr;
			UpdateData (FALSE);
		}
	}
}

void CSerialCommTestDlg::OnReadButton8() 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);

	CComboBox* pCfgRegListBox;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_UART_REG8);
	int nCurConfigSel;
	nCurConfigSel = pCfgRegListBox->GetCurSel();
	if (nCurConfigSel < 0)
	{
		// 
		// this should not happen as the write button would be 
		// enabled only if this list has proper Write reg value
		//
		MessageBox("Please select the Register to which Data to be written...!", "Warning! Register not selected", MB_OK|MB_ICONEXCLAMATION);			
	}
	else
	{
		CString tempStr;
		BYTE bReadData;
		if (ReadFromUart(7, nCurConfigSel, &bReadData))
		{
			tempStr.Format("%x", bReadData );
			tempStr.MakeUpper();

			m_ReadData8.Format("0x");
			m_ReadData8 += tempStr;
			UpdateData (FALSE);
		}
	}
}


BOOL
CSerialCommTestDlg::ReadFromUart(BYTE bPort, BYTE bReg, BYTE *pbValue )
{
	BOOL Status;
	DWORD  cbReturned;

	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	Status =	DeviceIoControl(pApp->m_structPort.hPortHandle[bPort],
						IOCTL_XRPORT_READ_UART_REG,
						&bReg,
						sizeof(BYTE),
						pbValue,
						sizeof(BYTE),
						&cbReturned,
						0);
	if (!Status)
	{		
		MessageBox("Error in Reading...!", "Error", MB_OK|MB_ICONERROR);
	}
	
	return Status;
	
}

BOOL
CSerialCommTestDlg::WriteToUart(BYTE bPort, BYTE bReg, BYTE bValue )
{
	BOOL Status;
	DWORD  cbReturned;
	
	CONFIG_WRITE cfgWrite;

	cfgWrite.bReg = bReg;
	cfgWrite.bData = bValue;

	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	Status =	DeviceIoControl(pApp->m_structPort.hPortHandle[bPort],
						(DWORD) IOCTL_XRPORT_WRITE_UART_REG,
						 &cfgWrite,
						 sizeof(CONFIG_WRITE),
						 NULL,
						 0,
						 &cbReturned,
						 0);
	if (!Status)
	{		
		MessageBox("Error in Writing...!", "Error", MB_OK|MB_ICONERROR);
	}	

	return Status;
}

void CSerialCommTestDlg::OnCfgWriteButton() 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);

	CComboBox* pCfgRegListBox;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_CONFIG_REG);
	int nCurConfigSel;
	nCurConfigSel = pCfgRegListBox->GetCurSel();
	if (nCurConfigSel < 0)
	{
		// 
		// this should not happen as the write button would be 
		// enabled only if this list has proper Write reg value
		//
		MessageBox("Please select the Register to which Data to be written...!", "Warning! Register not selected", MB_OK|MB_ICONEXCLAMATION);			
	}
	else
	{
		if ( (!m_CfgWriteData.GetLength()) || ! (m_CfgWriteData.Left(2) == ("0x")) )
		{
			MessageBox("Please input a value between 0x00 - 0xFF for write...!", "Warning! Improper value to Write", MB_OK|MB_ICONEXCLAMATION);			
			return;
		}		
	
		char *stopstring;
		BYTE bDataToReg = (BYTE)strtoul( m_CfgWriteData, &stopstring, 16 );

		cfgWrite(nCurConfigSel, bDataToReg);	
	}
	
}

void CSerialCommTestDlg::OnCfgReadButton() 
{
	// TODO: Add your control notification handler code here
	UpdateData (TRUE);

	CComboBox* pCfgRegListBox;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_CONFIG_REG);
	int nCurConfigSel;
	nCurConfigSel = pCfgRegListBox->GetCurSel();
	if (nCurConfigSel < 0)
	{
		// 
		// this should not happen as the write button would be 
		// enabled only if this list has proper Write reg value
		//
		MessageBox("Please select the Register to which Data to be written...!", "Warning! Register not selected", MB_OK|MB_ICONEXCLAMATION);			
	}
	else
	{		
		CString tempStr;
		BYTE bReadData;
		if (cfgRead(nCurConfigSel, &bReadData))
		{
			tempStr.Format("%x", bReadData );
			tempStr.MakeUpper();

			m_CfgReadData.Format("0x");
			m_CfgReadData += tempStr;
			UpdateData (FALSE);
		}
	}
	
}

void CSerialCommTestDlg::OnCloseupComboConfigReg() 
{
	// TODO: Add your control notification handler code here
	CComboBox* pCfgRegListBox;
	pCfgRegListBox = (CComboBox*)GetDlgItem(IDC_COMBO_CONFIG_REG);
	int nCurSel;
	nCurSel = pCfgRegListBox->GetCurSel();
	switch(nCurSel)
	{
	case 0x0:
	case 0x1:
	case 0x2:
	case 0x3:
	case 0x5:
//	case 0x9: //0x89 4xMode reg is r/w now
	case 0xC: 
	case 0xD:
		{
			// 
			// These registers are read only registers, so the write
			// button should be disabled
			//
			CButton* pbWrite;
			pbWrite = (CButton*)GetDlgItem(IDC_CFG_WRITE_BUTTON);
			if (pbWrite)
			{				
				pbWrite->EnableWindow(FALSE);; 
			}

			CEdit* pWriteEdit;
			pWriteEdit = (CEdit*)GetDlgItem(IDC_EDIT_CFG_WRITE);
			if (pWriteEdit)
			{				
				pWriteEdit->EnableWindow(FALSE);; 
			}
		}
		break;

	case 0x0A:
		{
			//
			// write only, so read should be disable
			// 
			CButton* pbRead;
			pbRead = (CButton*)GetDlgItem(IDC_CFG_READ_BUTTON);
			if (pbRead)
			{				
				pbRead->EnableWindow(FALSE);; 
			}
		}
		break;
		
	default:
		//
		// no need to do anything here as all other registers are R/W
		//
		break;
	}	
}

void CSerialCommTestDlg::OnDropdownComboConfigReg() 
{
	// TODO: Add your control notification handler code here
	CButton  *pbWrite, *pbRead;
	pbWrite = (CButton*)GetDlgItem(IDC_CFG_WRITE_BUTTON);
	if (pbWrite)
	{				
		pbWrite->EnableWindow(TRUE);; 
	}
	
	pbRead = (CButton*)GetDlgItem(IDC_CFG_READ_BUTTON);
	if (pbRead)
	{				
		pbRead->EnableWindow(TRUE);; 
	}

	CEdit* pWriteEdit;
	pWriteEdit = (CEdit*)GetDlgItem(IDC_EDIT_CFG_WRITE);
	if (pWriteEdit)
	{				
		pWriteEdit->EnableWindow(TRUE);
	}
}


BOOL 
CSerialCommTestDlg::cfgRead( BYTE bReg, BYTE *pbValue )
{
	BOOL Status;
	DWORD  cbReturned;
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	if (NULL == pApp)
	{
		Status = FALSE;
		MessageBox("First port not opened...!", "Error", MB_OK|MB_ICONERROR);
		return Status;
	}

	Status =	DeviceIoControl(pApp->m_structPort.hPortHandle[0],
						IOCTL_XRPORT_READ_CONFIG_REG,
						&bReg,
						sizeof(BYTE),
						pbValue,
						sizeof(BYTE),
						&cbReturned,
						0);
	if (!Status)
	{		
		MessageBox("Error in Reading...!", "Error", MB_OK|MB_ICONERROR);
	}
	
	return Status;

}

BOOL 
CSerialCommTestDlg::cfgWrite( BYTE bReg, BYTE bValue)
{
	BOOL Status;
	DWORD  cbReturned;
	
	CONFIG_WRITE cfgWrite;

	cfgWrite.bReg = bReg;
	cfgWrite.bData = bValue;

	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	if (NULL == pApp)
	{
		Status = FALSE;
		MessageBox("First port not opened...!", "Error", MB_OK|MB_ICONERROR);
		return Status;
	}

	Status =	DeviceIoControl(pApp->m_structPort.hPortHandle[0],
						(DWORD) IOCTL_XRPORT_WRITE_CONFIG_REG,
						 &cfgWrite,
						 sizeof(CONFIG_WRITE),
						 NULL,
						 0,
						 &cbReturned,
						 0);
	if (!Status)
	{		
		MessageBox("Error in Writing...!", "Error", MB_OK|MB_ICONERROR);
	}	

	return Status;

}

void CSerialCommTestDlg::OnButtonInduceerr1() 
{
	BYTE bErr = 0xFF;
	DWORD nActualWrite;
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	OVERLAPPED osWrite = {0};  // initialize the overlapped structure for write operations
	    
    osWrite.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);// create this writes overlapped structure hEvent
	if(osWrite.hEvent == NULL)
	{
		//MessageBox(AfxGetMainWnd()->m_hWnd,"Error creating overlapped write event handle","Write Error",MB_OK);
		return;
	}

	WriteFile(pApp->m_structPort.hPortHandle[0],&bErr,sizeof(BYTE),&nActualWrite,&osWrite);//overlapped write operation
	CloseHandle(osWrite.hEvent);	
}

void CSerialCommTestDlg::OnButtonInduceerr2() 
{
	BYTE bErr = 0xFF;
	DWORD nActualWrite;
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	OVERLAPPED osWrite = {0};  // initialize the overlapped structure for write operations
	    
    osWrite.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);// create this writes overlapped structure hEvent
	if(osWrite.hEvent == NULL)
	{
		//MessageBox(AfxGetMainWnd()->m_hWnd,"Error creating overlapped write event handle","Write Error",MB_OK);
		return;
	}

	WriteFile(pApp->m_structPort.hPortHandle[1],&bErr,sizeof(BYTE),&nActualWrite,&osWrite);//overlapped write operation
	CloseHandle(osWrite.hEvent);	
}

void CSerialCommTestDlg::OnButtonInduceerr3() 
{
	BYTE bErr = 0xFF;
	DWORD nActualWrite;
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	OVERLAPPED osWrite = {0};  // initialize the overlapped structure for write operations
	    
    osWrite.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);// create this writes overlapped structure hEvent
	if(osWrite.hEvent == NULL)
	{
		//MessageBox(AfxGetMainWnd()->m_hWnd,"Error creating overlapped write event handle","Write Error",MB_OK);
		return;
	}

	WriteFile(pApp->m_structPort.hPortHandle[2],&bErr,sizeof(BYTE),&nActualWrite,&osWrite);//overlapped write operation
	CloseHandle(osWrite.hEvent);	
}

void CSerialCommTestDlg::OnButtonInduceerr4() 
{
	BYTE bErr = 0xFF;
	DWORD nActualWrite;
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	OVERLAPPED osWrite = {0};  // initialize the overlapped structure for write operations
	    
    osWrite.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);// create this writes overlapped structure hEvent
	if(osWrite.hEvent == NULL)
	{
		//MessageBox(AfxGetMainWnd()->m_hWnd,"Error creating overlapped write event handle","Write Error",MB_OK);
		return;
	}

	WriteFile(pApp->m_structPort.hPortHandle[3],&bErr,sizeof(BYTE),&nActualWrite,&osWrite);//overlapped write operation
	CloseHandle(osWrite.hEvent);	
}

void CSerialCommTestDlg::OnButtonInduceerr5() 
{
	BYTE bErr = 0xFF;
	DWORD nActualWrite;
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	OVERLAPPED osWrite = {0};  // initialize the overlapped structure for write operations
	    
    osWrite.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);// create this writes overlapped structure hEvent
	if(osWrite.hEvent == NULL)
	{
		//MessageBox(AfxGetMainWnd()->m_hWnd,"Error creating overlapped write event handle","Write Error",MB_OK);
		return;
	}

	WriteFile(pApp->m_structPort.hPortHandle[4],&bErr,sizeof(BYTE),&nActualWrite,&osWrite);//overlapped write operation
	CloseHandle(osWrite.hEvent);	
}

void CSerialCommTestDlg::OnButtonInduceerr6() 
{
	BYTE bErr = 0xFF;
	DWORD nActualWrite;
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	OVERLAPPED osWrite = {0};  // initialize the overlapped structure for write operations
	    
    osWrite.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);// create this writes overlapped structure hEvent
	if(osWrite.hEvent == NULL)
	{
		//MessageBox(AfxGetMainWnd()->m_hWnd,"Error creating overlapped write event handle","Write Error",MB_OK);
		return;
	}

	WriteFile(pApp->m_structPort.hPortHandle[5],&bErr,sizeof(BYTE),&nActualWrite,&osWrite);//overlapped write operation
	CloseHandle(osWrite.hEvent);	
}

void CSerialCommTestDlg::OnButtonInduceerr7() 
{
	BYTE bErr = 0xFF;
	DWORD nActualWrite;
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	OVERLAPPED osWrite = {0};  // initialize the overlapped structure for write operations
	    
    osWrite.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);// create this writes overlapped structure hEvent
	if(osWrite.hEvent == NULL)
	{
		//MessageBox(AfxGetMainWnd()->m_hWnd,"Error creating overlapped write event handle","Write Error",MB_OK);
		return;
	}

	WriteFile(pApp->m_structPort.hPortHandle[6],&bErr,sizeof(BYTE),&nActualWrite,&osWrite);//overlapped write operation
	CloseHandle(osWrite.hEvent);	
}

void CSerialCommTestDlg::OnButtonInduceerr8() 
{
	BYTE bErr = 0xFF;
	DWORD nActualWrite;
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	OVERLAPPED osWrite = {0};  // initialize the overlapped structure for write operations
	    
    osWrite.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);// create this writes overlapped structure hEvent
	if(osWrite.hEvent == NULL)
	{
		//MessageBox(AfxGetMainWnd()->m_hWnd,"Error creating overlapped write event handle","Write Error",MB_OK);
		return;
	}

	WriteFile(pApp->m_structPort.hPortHandle[7],&bErr,sizeof(BYTE),&nActualWrite,&osWrite);//overlapped write operation
	CloseHandle(osWrite.hEvent);	
}

void CSerialCommTestDlg::OnButtonRunAll() 
{
	OnRun1();
	OnRun2();
	OnRun3();
	OnRun4();
	OnRun5();
	OnRun6();
	OnRun7();
	OnRun8();
	
}

void CSerialCommTestDlg::OnButtonStopAll() 
{
	OnStop1();
	OnStop2();
	OnStop3();
	OnStop4();
	OnStop5();
	OnStop6();
	OnStop7();
	OnStop8();	
}

void CSerialCommTestDlg::OnButtonSleepAll() 
{
	DWORD  cbReturned;

	//stop all the channels
	OnButtonStopAll();
		
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();

	for (int i=0; i<8; i++)
	if(pApp->m_structPort.bPortOpenFlag[i]) //only if the port represented by m_nPortNo was opened successfully
	{
		if (!DeviceIoControl( pApp->m_structPort.hPortHandle[i],
		(DWORD) IOCTL_XRPORT_UART_SLEEP,
		NULL,
		0,
		NULL,
		0,
		&cbReturned,
		0
		))
		{
			CString StrdlgError;
			StrdlgError = "IOCTL_XRPORT_UART_SLEEP not supported by this driver!";
			AfxGetMainWnd()->MessageBox(StrdlgError,"Error",MB_OK|MB_ICONEXCLAMATION);		
		}		
	}	
	
}

void CSerialCommTestDlg::OnButtonWakeAll() 
{
	DWORD  cbReturned;

	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();

	for (int i=0; i<8; i++)
	if(pApp->m_structPort.bPortOpenFlag[i]) //only if the port represented by m_nPortNo was opened successfully
	{
		if (!DeviceIoControl( pApp->m_structPort.hPortHandle[i],
		(DWORD) IOCTL_XRPORT_UART_WAKE,
		NULL,
		0,
		NULL,
		0,
		&cbReturned,
		0
		))
		{
			CString StrdlgError;
			StrdlgError = "IOCTL_XRPORT_UART_WAKE not supported by this driver!";
			AfxGetMainWnd()->MessageBox(StrdlgError,"Error",MB_OK|MB_ICONEXCLAMATION);		
		}		
	}
	
}
