#if !defined(AFX_SERIALCOMMTESTDLG_H__0CEC5D00_F287_11D3_856B_BAE3611DF462__INCLUDED_)
#define AFX_SERIALCOMMTESTDLG_H__0CEC5D00_F287_11D3_856B_BAE3611DF462__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// SerialCommTestDlg.h : header file
#include "ScrollDialog.h"
//

#define MAXPORTS 8
#include "Test.h"

/////////////////////////////////////////////////////////////////////////////
// CSerialCommTestDlg dialog

class CSerialCommTestDlg : public CScrollDialog
{
private:
	//local declarations	
	BOOL ReadFromUart( BYTE bPort, BYTE bReg, BYTE *pbValue );
	BOOL WriteToUart( BYTE bPort, BYTE bReg, BYTE bValue );	
	BOOL cfgRead( BYTE bReg, BYTE *pbValue );
	BOOL cfgWrite( BYTE bReg, BYTE bValue);	
// Construction
public:
	void OnClose();
	CTest m_Test;
	
	CSerialCommTestDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CSerialCommTestDlg)
	enum { IDD = IDD_SERIALTEST };
	CButton	m_buttonInduceErr1;
	CButton	m_buttonInduceErr2;
	CButton	m_buttonInduceErr3;
	CButton	m_buttonInduceErr4;
	CButton	m_buttonInduceErr5;
	CButton	m_buttonInduceErr6;
	CButton	m_buttonInduceErr7;
	CButton	m_buttonInduceErr8;
	CEdit	m_editPacCount8;
	CEdit	m_editPacCount7;
	CEdit	m_editPacCount6;
	CEdit	m_editPacCount5;
	CEdit	m_editPacCount4;
	CEdit	m_editPacCount3;
	CEdit	m_editPacCount2;
	CEdit	m_editPacCount1;
	CButton	m_checkDisONOFF8;
	CButton	m_checkDisONOFF7;
	CButton	m_checkDisONOFF6;
	CButton	m_checkDisONOFF5;
	CButton	m_checkDisONOFF4;
	CButton	m_checkDisONOFF3;
	CButton	m_checkDisONOFF2;
	CButton	m_checkDisONOFF1;	
	CButton	m_radioForever8;
	CEdit	m_editHrTime8;
	CEdit	m_editHrTime7;
	CEdit	m_editHrTime6;
	CEdit	m_editHrTime5;
	CEdit	m_editMinTime8;
	CEdit	m_editMinTime7;
	CEdit	m_editMinTime6;
	CEdit	m_editMinTime5;
	CButton	m_radioForever7;
	CButton	m_radioForever6;
	CButton	m_radioForever5;
	CButton	m_radioStopError8;
	CButton	m_radioStopError7;
	CButton	m_radioStopError6;
	CButton	m_radioStopTime8;
	CButton	m_radioStopError5;
	CButton	m_radioStopTime7;
	CButton	m_radioStopTime6;
	CButton	m_radioStopTime5;
	CButton	m_buttonStop8;
	CButton	m_buttonStop7;
	CButton	m_buttonStop6;
	CButton	m_buttonStop5;
	CButton	m_buttonRun8;
	CButton	m_buttonRun7;
	CButton	m_buttonRun6;
	CButton	m_buttonRun5;
	CButton	m_checkLoopTest8;
	CButton	m_checkLoopTest7;
	CButton	m_checkLoopTest5;
	CButton	m_checkLoopTest6;
	CEdit	m_editTx8;
	CEdit	m_editTx7;
	CEdit	m_editTx6;
	CEdit	m_editTx5;
	CEdit	m_editRx8;
	CEdit	m_editRx7;
	CEdit	m_editRx6;
	CEdit	m_editRx5;
	CEdit	m_editMinTime4;
	CEdit	m_editHrTime4;
	CButton	m_radioStopError4;
	CButton	m_radioStopError3;
	CButton	m_radioStopTime4;
	CButton	m_radioStopTime3;
	CButton	m_radioForever4;
	CButton	m_radioForever3;
	CEdit	m_editMinTime3;
	CEdit	m_editHrTime3;	
	CButton	m_buttonStop4;
	CButton	m_buttonStop3;	
	CButton	m_buttonRun4;
	CButton	m_buttonRun3;
	CButton	m_checkLoopTest4;
	CButton	m_checkLoopTest3;
	CEdit	m_editTx4;
	CEdit	m_editTx3;
	CEdit	m_editRx4;
	CEdit	m_editRx3;
	CButton	m_checkLoopTest2;
	CEdit	m_editMinTime2;
	CEdit	m_editHrTime2;
	CButton	m_radioForever2;
	CButton	m_radioStopError2;
	CButton	m_radioStopTime2;
	CButton	m_buttonStop2;
	CEdit	m_editTx2;
	CEdit	m_editRx2;
	CButton	m_buttonRun2;	
	CEdit	m_editMinTime1;
	CEdit	m_editHrTime1;
	CButton	m_buttonTransfer8;
	CButton	m_buttonTransfer7;
	CButton	m_buttonTransfer6;
	CButton	m_buttonTransfer5;
	CButton	m_buttonTransfer4;
	CButton	m_buttonTransfer3;
	CButton	m_buttonTransfer2;	
	CEdit	m_editTx1;
	CEdit	m_editRx1;
	CButton	m_radioStopError1;
	CButton	m_radioStopTime1;
	CButton	m_radioForever1;
	CButton	m_checkLoopTest1;
	CButton	m_buttonTransfer1;
	CButton	m_buttonStop1;
	CButton	m_buttonRun1;
	CButton	m_checkDataErrorCheckONOFF1;
	CButton	m_checkDataErrorCheckONOFF2;
	CButton	m_checkDataErrorCheckONOFF3;
	CButton	m_checkDataErrorCheckONOFF4;
	CButton	m_checkDataErrorCheckONOFF5;
	CButton	m_checkDataErrorCheckONOFF6;
	CButton	m_checkDataErrorCheckONOFF7;
	CButton	m_checkDataErrorCheckONOFF8;
	CString	m_ReadData1;
	CString	m_ReadData2;
	CString	m_ReadData3;
	CString	m_ReadData4;
	CString	m_ReadData5;
	CString	m_ReadData6;
	CString	m_ReadData7;
	CString	m_ReadData8;
	CString	m_WriteData1;
	CString	m_WriteData2;
	CString	m_WriteData3;
	CString	m_WriteData4;
	CString	m_WriteData5;
	CString	m_WriteData6;
	CString	m_WriteData7;
	CString	m_WriteData8;
	CString	m_CfgWriteData;
	CString	m_CfgReadData;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSerialCommTestDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CSerialCommTestDlg)
	virtual void OnOK();
	afx_msg void OnTransfer1();
	virtual BOOL OnInitDialog();
	afx_msg void OnStoponTime1();
	afx_msg void OnStoponError1();
	afx_msg void OnTestForever1();
	afx_msg void OnRun1();
	afx_msg void OnMaxtextTx1();
	afx_msg void OnMaxtextRx1();
	afx_msg void OnTransfer2();
	afx_msg void OnTransfer3();
	afx_msg void OnTransfer4();
	afx_msg void OnTransfer5();
	afx_msg void OnTransfer6();
	afx_msg void OnTransfer7();
	afx_msg void OnTransfer8();
	afx_msg void OnStop1();
	afx_msg void OnRun2();
	afx_msg void OnStop2();
	afx_msg void OnMaxtextTx2();
	afx_msg void OnMaxtextRx2();
	afx_msg void OnMaxtextRx3();
	afx_msg void OnMaxtextRx4();
	afx_msg void OnMaxtextTx3();
	afx_msg void OnMaxtextTx4();
	afx_msg void OnStop3();
	afx_msg void OnStop4();
	afx_msg void OnRun3();
	afx_msg void OnRun4();
	afx_msg void OnStoponError2();
	afx_msg void OnStoponError3();
	afx_msg void OnStoponError4();
	afx_msg void OnStoponTime2();
	afx_msg void OnStoponTime3();
	afx_msg void OnStoponTime4();
	afx_msg void OnTestforever2();
	afx_msg void OnTestforever3();
	afx_msg void OnTestforever4();
	afx_msg void OnRun5();
	afx_msg void OnRun6();
	afx_msg void OnRun7();
	afx_msg void OnRun8();
	afx_msg void OnStop5();
	afx_msg void OnStop6();
	afx_msg void OnStop7();
	afx_msg void OnStop8();
	afx_msg void OnStoponError5();
	afx_msg void OnStoponError6();
	afx_msg void OnStoponError7();
	afx_msg void OnStoponError8();
	afx_msg void OnTestForever5();
	afx_msg void OnTestForever6();
	afx_msg void OnTestForever7();
	afx_msg void OnTestForever8();
	afx_msg void OnStoponTime5();
	afx_msg void OnStoponTime6();
	afx_msg void OnStoponTime7();
	afx_msg void OnStoponTime8();
	afx_msg void OnMaxtextRx5();
	afx_msg void OnMaxtextRx6();
	afx_msg void OnMaxtextRx7();
	afx_msg void OnMaxtextRx8();
	afx_msg void OnMaxtextTx5();
	afx_msg void OnMaxtextTx6();
	afx_msg void OnMaxtextTx7();
	afx_msg void OnMaxtextTx8();/*
	afx_msg void OnLooptest1();
	afx_msg void OnLooptest2();
	afx_msg void OnLooptest3();
	afx_msg void OnLooptest4();
	afx_msg void OnLooptest5();
	afx_msg void OnLooptest6();
	afx_msg void OnLooptest7();
	afx_msg void OnLooptest8();*/
	afx_msg void OnWriteButton1();
	afx_msg void OnWriteButton2();
	afx_msg void OnWriteButton3();
	afx_msg void OnWriteButton4();
	afx_msg void OnWriteButton5();
	afx_msg void OnWriteButton6();
	afx_msg void OnWriteButton7();
	afx_msg void OnWriteButton8();
	afx_msg void OnReadButton1();
	afx_msg void OnReadButton2();
	afx_msg void OnReadButton3();
	afx_msg void OnReadButton4();
	afx_msg void OnReadButton5();
	afx_msg void OnReadButton6();
	afx_msg void OnReadButton7();
	afx_msg void OnReadButton8();
	afx_msg void OnCfgWriteButton();
	afx_msg void OnCfgReadButton();
	afx_msg void OnCloseupComboConfigReg();
	afx_msg void OnDropdownComboConfigReg();
	afx_msg void OnButtonInduceerr1();
	afx_msg void OnButtonInduceerr2();
	afx_msg void OnButtonInduceerr3();
	afx_msg void OnButtonInduceerr4();
	afx_msg void OnButtonInduceerr5();
	afx_msg void OnButtonInduceerr6();
	afx_msg void OnButtonInduceerr7();
	afx_msg void OnButtonInduceerr8();
	afx_msg void OnButtonRunAll();
	afx_msg void OnButtonStopAll();
	afx_msg void OnButtonSleepAll();
	afx_msg void OnButtonWakeAll();
	//}}AFX_MSG
public:
	afx_msg void OnLooptest1();
	afx_msg void OnLooptest2();
	afx_msg void OnLooptest3();
	afx_msg void OnLooptest4();
	afx_msg void OnLooptest5();
	afx_msg void OnLooptest6();
	afx_msg void OnLooptest7();
	afx_msg void OnLooptest8();
	
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SERIALCOMMTESTDLG_H__0CEC5D00_F287_11D3_856B_BAE3611DF462__INCLUDED_)
